package ubiware.core;

import java.util.Set;

import ubiware.util.saplbuilder.InvalidResourceException;
import ubiware.util.saplbuilder.Resource;

/**
 * A binding is a collection of values which are bound to certain variables. Classes implementing this interface implement the get method
 * which returns the value associated with the variable name
 * 
 * 23.6.2010
 * 
 * @author Michael Cochez for UBIWARE project
 */
public interface Binding {
	/**
	 * get the value bound to this variable name
	 * 
	 * @param variablename
	 *            the variable name for which the value is requested
	 * @return the value
	 */
	String get(String variablename);

	Resource getResource(String variableName) throws InvalidResourceException;

	Set<String> getVariables();

}
