package ubiware.core;

import jade.util.leap.Serializable;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;

public class ContextContainer implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	//ALL ID's are ID's in the beliefs map the agent holds.
	//ID's of the members of this context.
	public List<String> members; //IDs

	//if understood correctly: Those maps care used to speed up searching for a statement in the container
	//this means they map the String value of a S/P/O to a set of ID's of statements which have those stringvalues as S/P/O
	public HashMap<String, HashSet<String>> index_sub = null;
	public HashMap<String, HashSet<String>> index_pred = null;
	public HashMap<String, HashSet<String>> index_ob = null;

	//?? Vector containing all IDs of statements which have variables in them
	public List<String> statementsWithVariables = null;

	public String referencedBy = null; //ID of the referencing statement
	public int referenced = 0; //times it appears in statements (if it is more than 1,

	//it means that it is linked also to a running RAB)

	public ContextContainer() {
		this(4); //4 is a good number, the mebersize of HashSets has to be a power of 2 and 2 would be too small.
	}

	public ContextContainer(int membersSize) {
		this.members = new ArrayList<String>(membersSize);
		this.index_sub = new HashMap<String, HashSet<String>>(membersSize);
		this.index_pred = new HashMap<String, HashSet<String>>(membersSize);
		this.index_ob = new HashMap<String, HashSet<String>>(membersSize);
	}

	@Override
	public String toString() {
		return this.members.toString() + " (" + String.valueOf(this.referenced) + ")";
	}

}
