package ubiware.core;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.Stack;
import java.util.TimeZone;

import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;

import ubiware.util.IDGenerator;

public class ExpressionEvaluator {

	private static final String a[][] = new String[ExpressionEvaluator.uCount][ExpressionEvaluator.tCount];
	static {
		ExpressionEvaluator.a[0][0] = "BE";
		ExpressionEvaluator.a[0][1] = "BE";
		ExpressionEvaluator.a[0][2] = "";
		ExpressionEvaluator.a[0][3] = "BE";
		ExpressionEvaluator.a[0][4] = "";
		ExpressionEvaluator.a[0][5] = "";
		ExpressionEvaluator.a[0][6] = "BE";
		ExpressionEvaluator.a[0][7] = "BE";
		ExpressionEvaluator.a[0][8] = "";
		ExpressionEvaluator.a[0][9] = "";
		ExpressionEvaluator.a[0][10] = "";
		ExpressionEvaluator.a[1][0] = "CF";
		ExpressionEvaluator.a[1][1] = "CF";
		ExpressionEvaluator.a[1][2] = "";
		ExpressionEvaluator.a[1][3] = "CF";
		ExpressionEvaluator.a[1][4] = "";
		ExpressionEvaluator.a[1][5] = "";
		ExpressionEvaluator.a[1][6] = "CF";
		ExpressionEvaluator.a[1][7] = "CF";
		ExpressionEvaluator.a[1][8] = "";
		ExpressionEvaluator.a[1][9] = "";
		ExpressionEvaluator.a[1][10] = "";
		ExpressionEvaluator.a[2][0] = "D";
		ExpressionEvaluator.a[2][1] = "D";
		ExpressionEvaluator.a[2][2] = "";
		ExpressionEvaluator.a[2][3] = "-Du";
		ExpressionEvaluator.a[2][4] = "";
		ExpressionEvaluator.a[2][5] = "";
		ExpressionEvaluator.a[2][6] = "D";
		ExpressionEvaluator.a[2][7] = "D";
		ExpressionEvaluator.a[2][8] = "";
		ExpressionEvaluator.a[2][9] = "";
		ExpressionEvaluator.a[2][10] = "";
		ExpressionEvaluator.a[3][0] = "G";
		ExpressionEvaluator.a[3][1] = "G";
		ExpressionEvaluator.a[3][2] = "";
		ExpressionEvaluator.a[3][3] = "";
		ExpressionEvaluator.a[3][4] = "";
		ExpressionEvaluator.a[3][5] = "";
		ExpressionEvaluator.a[3][6] = "@o(I)f";
		ExpressionEvaluator.a[3][7] = "G";
		ExpressionEvaluator.a[3][8] = "";
		ExpressionEvaluator.a[3][9] = "";
		ExpressionEvaluator.a[3][10] = "";
		ExpressionEvaluator.a[4][0] = "";
		ExpressionEvaluator.a[4][1] = "";
		ExpressionEvaluator.a[4][2] = "+BaE";
		ExpressionEvaluator.a[4][3] = "-BsE";
		ExpressionEvaluator.a[4][4] = "";
		ExpressionEvaluator.a[4][5] = "";
		ExpressionEvaluator.a[4][6] = "";
		ExpressionEvaluator.a[4][7] = "";
		ExpressionEvaluator.a[4][8] = "_";
		ExpressionEvaluator.a[4][9] = "_";
		ExpressionEvaluator.a[4][10] = "_";
		ExpressionEvaluator.a[5][0] = "";
		ExpressionEvaluator.a[5][1] = "";
		ExpressionEvaluator.a[5][2] = "_";
		ExpressionEvaluator.a[5][3] = "_";
		ExpressionEvaluator.a[5][4] = "*CmF";
		ExpressionEvaluator.a[5][5] = "/CdF";
		ExpressionEvaluator.a[5][6] = "";
		ExpressionEvaluator.a[5][7] = "";
		ExpressionEvaluator.a[5][8] = "_";
		ExpressionEvaluator.a[5][9] = "_";
		ExpressionEvaluator.a[5][10] = "_";
		ExpressionEvaluator.a[6][0] = "!";
		ExpressionEvaluator.a[6][1] = "?";
		ExpressionEvaluator.a[6][2] = "";
		ExpressionEvaluator.a[6][3] = "";
		ExpressionEvaluator.a[6][4] = "";
		ExpressionEvaluator.a[6][5] = "";
		ExpressionEvaluator.a[6][6] = "";
		ExpressionEvaluator.a[6][7] = "(A)";
		ExpressionEvaluator.a[6][8] = "";
		ExpressionEvaluator.a[6][9] = "";
		ExpressionEvaluator.a[6][10] = "";
		ExpressionEvaluator.a[7][0] = "A#";
		ExpressionEvaluator.a[7][1] = "A#";
		ExpressionEvaluator.a[7][2] = "";
		ExpressionEvaluator.a[7][3] = "A#";
		ExpressionEvaluator.a[7][4] = "";
		ExpressionEvaluator.a[7][5] = "";
		ExpressionEvaluator.a[7][6] = "A#";
		ExpressionEvaluator.a[7][7] = "A#";
		ExpressionEvaluator.a[7][8] = "";
		ExpressionEvaluator.a[7][9] = "";
		ExpressionEvaluator.a[7][10] = "";
		ExpressionEvaluator.a[8][0] = "AJ";
		ExpressionEvaluator.a[8][1] = "AJ";
		ExpressionEvaluator.a[8][2] = "";
		ExpressionEvaluator.a[8][3] = "AJ";
		ExpressionEvaluator.a[8][4] = "";
		ExpressionEvaluator.a[8][5] = "";
		ExpressionEvaluator.a[8][6] = "AJ";
		ExpressionEvaluator.a[8][7] = "AJ";
		ExpressionEvaluator.a[8][8] = "_";
		ExpressionEvaluator.a[8][9] = "";
		ExpressionEvaluator.a[8][10] = "";
		ExpressionEvaluator.a[9][0] = "";
		ExpressionEvaluator.a[9][1] = "";
		ExpressionEvaluator.a[9][2] = "";
		ExpressionEvaluator.a[9][3] = "";
		ExpressionEvaluator.a[9][4] = "";
		ExpressionEvaluator.a[9][5] = "";
		ExpressionEvaluator.a[9][6] = "";
		ExpressionEvaluator.a[9][7] = "";
		ExpressionEvaluator.a[9][8] = "_";
		ExpressionEvaluator.a[9][9] = ",AJ";
		ExpressionEvaluator.a[9][10] = "";
	}
	private static final int tCount = 11;
	private static final char t[] = new char[ExpressionEvaluator.tCount];
	static {
		ExpressionEvaluator.t[0] = '!';
		ExpressionEvaluator.t[1] = '?';
		ExpressionEvaluator.t[2] = '+';
		ExpressionEvaluator.t[3] = '-';
		ExpressionEvaluator.t[4] = '*';
		ExpressionEvaluator.t[5] = '/';
		ExpressionEvaluator.t[6] = '@';
		ExpressionEvaluator.t[7] = '(';
		ExpressionEvaluator.t[8] = ')';
		ExpressionEvaluator.t[9] = ',';
		ExpressionEvaluator.t[10] = '#';
	}

	private static final int uCount = 10;

	//private static final int fCount = 29;
	private static final Set<String> functions; //= new String[ExpressionEvaluator.fCount];
	static {
		Set<String> functionsSet = new HashSet<String>();
		functionsSet.add("abs");
		functionsSet.add("sqrt");
		functionsSet.add("random");
		functionsSet.add("pow");
		functionsSet.add("ceil");
		functionsSet.add("floor");
		functionsSet.add("round");
		functionsSet.add("length");
		functionsSet.add("substring");
		functionsSet.add("replace");
		functionsSet.add("replaceAll");
		functionsSet.add("startsWith");
		functionsSet.add("endsWith");
		functionsSet.add("contains");
		functionsSet.add("indexOf");
		functionsSet.add("lastIndexOf");
		functionsSet.add("getNameSpace");
		functionsSet.add("getLocalName");
		functionsSet.add("trim");
		functionsSet.add("exists");
		functionsSet.add("timeMillis");
		functionsSet.add("timeString");
		functionsSet.add("numberOfMembers");
		functionsSet.add("toLowerCase");
		functionsSet.add("toUpperCase");
		functionsSet.add("min");
		functionsSet.add("max");
		functionsSet.add("valueOf");
		functionsSet.add("ID");
		//functions = Collections.unmodifiableSet(functionsSet); //unmodifiable is not needed since this set is not public!
		functions = functionsSet;
	}

	private static final String error[] = { "Syntax error" };

	private String errorMessage = "";

	public ExpressionEvaluator() {
		//TODO can this class be converted to a static library?
	}

	//generates the IDGenerator for the ID function, an example ID is <http://www.ubiware.jyu.fi/id#expressionEvaluator_40498159194546746_1279028904845_3691>
	private static IDGenerator idgenerator = new IDGenerator("expressionEvaluator_" + String.valueOf(Math.random()).substring(2));

	/**
	 * 
	 * @return the errorMessage of the ExpressionEvaluator, this will be null if no error occured
	 */
	public String getErrorMessage() {
		return this.errorMessage;
	}

	public String calculate(String text, String textID, HashMap<String, String> vars, StringBuilder errorMsg, UbiwareAgent myAgent) {
		List<String> code = this.compile(text, textID);
		if (code == null) {
			errorMsg.append(this.errorMessage);
			return null;
		} else {
			String result = this.evaluate(code, textID, vars, myAgent);
			errorMsg.append(this.errorMessage);
			return result;
		}
	}

	public List<String> tokenize(String text) {
		List<String> tokens = new ArrayList<String>();
		StringBuilder lexStringBuilder = new StringBuilder();
		this.lexicalAnalysis(text, tokens, lexStringBuilder);
		return tokens;
	}

	public List<String> compile(String text, String textID) {
		List<String> tokens = new ArrayList<String>();
		StringBuilder lexStringBuilder = new StringBuilder();
		this.lexicalAnalysis(text, tokens, lexStringBuilder);
		List<String> code = new ArrayList<String>();
		if (this.syntaxAnalysis(tokens, lexStringBuilder.toString(), code, textID)) {
			return code;
		} else {
			return null;
		}
	}

	void addLexSymbol(String word, StringBuilder lexStringBuilder) {
		//for (int i = 0; i < ExpressionEvaluator.fCount; i++) {
		//	if (word.equals(ExpressionEvaluator.funcs[i])) {
		//		lexStringBuilder.append('@');
		//		return;
		//	}
		//}
		if (ExpressionEvaluator.functions.contains(word)) {
			lexStringBuilder.append('@');
			return;
		}

		if (word.startsWith("?")) {
			lexStringBuilder.append('?');
		} else {
			lexStringBuilder.append('!');
		}
	}

	void lexicalAnalysis(String text, List<String> tokens, StringBuilder lexStringBuilder) {
		boolean inside_literal = false;
		char literal_start = ' ';
		int len = text.length();
		int tokS = 0;
		for (int c = 0; c < len; c++) {
			char ch = text.charAt(c);
			if (!inside_literal && ((ch == '"') || (ch == '<'))) {
				inside_literal = true;
				literal_start = ch;
			} else if (inside_literal && (((ch == '"') && (literal_start == '"')) || ((ch == '>') && (literal_start == '<')))) {
				inside_literal = false;
			} else if (!inside_literal
					&& ((ch == '(') || (ch == ')') || (ch == '+') || (ch == '-') || (ch == '*') || (ch == '/') || (ch == ','))) {
				if (tokS != c) {
					String word = text.substring(tokS, c).trim();
					tokens.add(word);
					this.addLexSymbol(word, lexStringBuilder);
				}
				tokens.add("" + ch);
				lexStringBuilder.append(ch);
				tokS = c + 1;
			}
		}
		if (tokS < len) {
			String rest = text.substring(tokS, len).trim();
			tokens.add(rest);
			this.addLexSymbol(rest, lexStringBuilder);
		}
	}

	boolean syntaxAnalysis(List<String> tokens, String lexString, List<String> code, String textID) {
		lexString += '#';
		StringBuilder curString = new StringBuilder();
		curString.append('H');
		int iLex = 0;
		int iCur = 0;

		while (true) {
			while ((curString.charAt(iCur) >= 'a') && (curString.charAt(iCur) <= 'z')) {
				code.add("{@$@}" + curString.charAt(iCur));
				iCur++;
			}

			char ch = curString.charAt(iCur);
			char lex_ch = lexString.charAt(iLex);
			if (ch == lex_ch) {
				if (ch == '#') {
					return true;
				} else if ((ch == '?') || (ch == '!') || (ch == '@')) {
					String token = tokens.get(iLex);
					code.add(token);
				}
				iCur++;
				iLex++;
			} else {
				int iy = ch - 'A';
				if ((iy < 0) || (iy > ExpressionEvaluator.uCount)) {
					this.errorMessage = "Syntax Error in " + textID;
					return false;
				}
				int ix = -1;
				for (int i = 0; i < ExpressionEvaluator.tCount; i++) {
					if (ExpressionEvaluator.t[i] == lex_ch) {
						ix = i;
						break;
					}
				}

				String fromTable = ExpressionEvaluator.a[iy][ix];

				if (fromTable.equals("") || fromTable.startsWith("$")) {
					//String err = "";
					//if (fromTable.startsWith("$")) {
					//	int ind = Integer.valueOf(fromTable.substring(1));
					//	err = ExpressionEvaluator.error[ind];
					//}
					this.errorMessage = "Syntax Error in " + textID;
					return false;
				} else if (fromTable.equals("_")) {
					curString.deleteCharAt(iCur);
				} else {
					curString.replace(iCur, iCur + 1, fromTable);
				}

			}
		}
	}

	String makeStringValue(double v) {
		double d = Math.floor(v);
		if (d == v) {
			return String.valueOf((long) d);
		} else {
			return String.valueOf(v);
		}
	}

	public String evaluate(List<String> code, String textID, HashMap<String, String> vars, UbiwareAgent myAgent) {
		Stack<String> stack = new Stack<String>();
		for (String command : code) {
			//Iterator<String> it = code.iterator();
			//while (it.hasNext()) {
			//	String command = it.next();
			if (command.equals("{@$@}a") || command.equals("{@$@}s") || command.equals("{@$@}m") || command.equals("{@$@}d")) {
				String value1 = stack.pop();
				String value2 = stack.pop();
				boolean numberValues = true;
				double v1 = 0, v2 = 0;
				try {
					v1 = Double.valueOf(value1);
					v2 = Double.valueOf(value2);
				} catch (NumberFormatException e) {
					numberValues = false;
				}

				if (command.equals("{@$@}a")) {
					if (numberValues) {
						stack.push(this.makeStringValue(v2 + v1));
					} else {
						stack.push(value2 + value1);
					}
				} else if (command.equals("{@$@}s")) {
					if (numberValues) {
						stack.push(this.makeStringValue(v2 - v1));
					} else {
						this.errorMessage = "Error in " + textID + ": Only numbers can be operands of \"-\"";
						return null;
					}
				} else if (command.equals("{@$@}m")) {
					if (numberValues) {
						stack.push(this.makeStringValue(v2 * v1));
					} else {
						this.errorMessage = "Error in " + textID + ": Only numbers can be operands of \"*\"";
						return null;
					}
				} else if (command.equals("{@$@}d")) {
					if (numberValues) {
						stack.push(this.makeStringValue(v2 / v1));
					} else {
						this.errorMessage = "Error in " + textID + ": Only numbers can be operands of \"/\"";
						return null;
					}
				}
			}

			else if (command.equals("{@$@}u")) {
				String value1 = stack.pop();
				boolean numberValues = true;
				double v1 = 0;
				try {
					v1 = Double.valueOf(value1);
				} catch (NumberFormatException e) {
					numberValues = false;
				}

				if (command.equals("{@$@}u")) {
					if (numberValues) {
						stack.push(this.makeStringValue(-1 * v1));
					} else {
						this.errorMessage = "Error in " + textID + ": Only a number can be operand of unary \"-\"";
						return null;
					}
				}
			}

			else if (command.equals("{@$@}f")) {
				List<String> operands = new ArrayList<String>();
				List<Double> dOperands = new ArrayList<Double>();
				while (true) {
					String value = stack.pop();
					if (value.equals("{@$@}o")) {
						break;
					}
					operands.add(value);
					try {
						Double v = Double.valueOf(value);
						dOperands.add(v);
					} catch (NumberFormatException e) {
						dOperands.add(null);
					}
				}

				String func = stack.pop();
				//math functions
				if (func.equals("abs")) {
					if (dOperands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"abs\" must have exactly one operand";
						return null;
					}
					Double v = dOperands.get(0);
					if (v == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be operand of \"abs\"";
						return null;
					}
					stack.push(this.makeStringValue(Math.abs(v)));
				} else if (func.equals("sqrt")) {
					if (dOperands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"sqrt\" must have exactly one operand";
						return null;
					}
					Double v = dOperands.get(0);
					if (v == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be operand of \"sqrt\"";
						return null;
					}
					stack.push(this.makeStringValue(Math.sqrt(v)));
				} else if (func.equals("random")) {
					if (dOperands.size() != 0) {
						this.errorMessage = "Error in " + textID + ": \"random\" must have no operands";
						return null;
					}
					stack.push(this.makeStringValue(Math.random()));
				} else if (func.equals("ceil")) {
					if (dOperands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"ceil\" must have exactly one operand";
						return null;
					}
					Double v = dOperands.get(0);
					if (v == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be operand of \"ceil\"";
						return null;
					}
					stack.push(this.makeStringValue(Math.ceil(v)));
				} else if (func.equals("floor")) {
					if (dOperands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"floor\" must have exactly one operand";
						return null;
					}
					Double v = dOperands.get(0);
					if (v == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be operand of \"floor\"";
						return null;
					}
					stack.push(this.makeStringValue(Math.floor(v)));
				} else if (func.equals("round")) {
					if ((dOperands.size() != 1) && (dOperands.size() != 2)) {
						this.errorMessage = "Error in " + textID + ": \"round\" must have one or two operands";
						return null;
					}
					Double v2 = 0.0;
					int i = 0;
					if (operands.size() == 2) {
						v2 = dOperands.get(i++);
					}
					Double v1 = dOperands.get(i);
					if ((v1 == null) || (v2 == null)) {
						this.errorMessage = "Error in " + textID + ": Only numbers can be operands of \"round\"";
						return null;
					}
					if (operands.size() == 1) {
						stack.push(this.makeStringValue(Math.round(v1)));
					} else {
						if (v2 < 0) {
							this.errorMessage = "Error in " + textID + ": The second operand of \"round\" must be >=0";
							return null;
						}
						stack.push(this.makeStringValue((Math.round(v1 * Math.pow(10, v2))) / Math.pow(10, v2)));
					}
				} else if (func.equals("pow")) {
					if (dOperands.size() != 2) {
						this.errorMessage = "Error in " + textID + ": \"round\" must have exactly two operands";
						return null;
					}
					Double v2 = dOperands.get(0);
					Double v1 = dOperands.get(1);
					if ((v1 == null) || (v2 == null)) {
						this.errorMessage = "Error in " + textID + ": Only numbers can be operand of \"round\"";
						return null;
					}
					stack.push(this.makeStringValue(Math.pow(v1, v2)));
				}

				//math and string
				else if (func.equals("min")) {
					if (operands.size() != 2) {
						this.errorMessage = "Error in " + textID + ": \"min\" must have exactly two operands";
						return null;
					}
					Double v2 = dOperands.get(0);
					Double v1 = dOperands.get(1);
					if ((v1 != null) && (v2 != null)) {
						stack.push(this.makeStringValue(Math.min(v1, v2)));

					} else {
						String sv2 = operands.get(0);
						String sv1 = operands.get(1);
						if (sv1.compareTo(sv2) <= 0) {
							stack.push(sv1);
						} else {
							stack.push(sv2);
						}
					}
				} else if (func.equals("max")) {
					if (operands.size() != 2) {
						this.errorMessage = "Error in " + textID + ": \"max\" must have exactly two operands";
						return null;
					}
					Double v2 = dOperands.get(0);
					Double v1 = dOperands.get(1);
					if ((v1 != null) && (v2 != null)) {
						stack.push(this.makeStringValue(Math.max(v1, v2)));
					} else {
						String sv2 = operands.get(0);
						String sv1 = operands.get(1);
						if (sv1.compareTo(sv2) >= 0) {
							stack.push(sv1);
						} else {
							stack.push(sv2);
						}
					}
				}

				//string-processing functions
				else if (func.equals("length")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"length\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					stack.push(this.makeStringValue(v.length()));
				} else if (func.equals("trim")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"trim\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					stack.push(v.trim());
				} else if (func.equals("substring")) {
					if ((operands.size() != 2) && (operands.size() != 3)) {
						this.errorMessage = "Error in " + textID + ": \"substring\" must have two or three operands";
						return null;
					}
					Double v3 = 0.0;
					int i = 0;
					if (operands.size() == 3) {
						v3 = dOperands.get(i++);
					}
					Double v2 = dOperands.get(i++);
					String v1 = operands.get(i);

					if (v2 == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be the second operand of \"substring\"";
						return null;
					}
					if (v3 == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be the third operand of \"substring\"";
						return null;
					}

					int ind1 = (int) v2.doubleValue();
					if (ind1 < 0) {
						ind1 = v1.length();
					}
					int ind2;
					if ((operands.size() < 3) || ((ind2 = (int) v3.doubleValue()) < 0)) {
						ind2 = v1.length();
					}
					String result = null;
					try {
						result = v1.substring(ind1, ind2);
					} catch (IndexOutOfBoundsException e) {
						this.errorMessage = "Error in " + textID + ": \"substring\" indices " + String.valueOf(ind1) + " and "
								+ String.valueOf(ind2) + " are out of bounds for the string \"" + v1 + "\"";
						return null;
					}
					stack.push(result);
				} else if (func.equals("replace")) {
					if (operands.size() != 3) {
						this.errorMessage = "Error in " + textID + ": \"replace\" must have exactly three operands";
						return null;
					}
					String v3 = operands.get(0);
					String v2 = operands.get(1);
					String v1 = operands.get(2);
					stack.push(v1.replace(v2, v3));
				} else if (func.equals("replaceAll")) {
					if (operands.size() != 3) {
						this.errorMessage = "Error in " + textID + ": \"replaceAll\" must have exactly three operands";
						return null;
					}
					String v3 = operands.get(0);
					String v2 = operands.get(1);
					String v1 = operands.get(2);
					stack.push(v1.replaceAll(v2, v3));
				} else if (func.equals("startsWith")) {
					if (operands.size() != 2) {
						this.errorMessage = "Error in " + textID + ": \"startsWith\" must have exactly two operands";
						return null;
					}
					String v2 = operands.get(0);
					String v1 = operands.get(1);
					if (v1.startsWith(v2)) {
						stack.push(SaplN3Constants.TRUE);
					} else {
						stack.push(SaplN3Constants.FALSE);
					}
				} else if (func.equals("endsWith")) {
					if (operands.size() != 2) {
						this.errorMessage = "Error in " + textID + ": \"endsWith\" must have exactly two operands";
						return null;
					}
					String v2 = operands.get(0);
					String v1 = operands.get(1);
					if (v1.endsWith(v2)) {
						stack.push(SaplN3Constants.TRUE);
					} else {
						stack.push(SaplN3Constants.FALSE);
					}
				} else if (func.equals("contains")) {
					if (operands.size() != 2) {
						this.errorMessage = "Error in " + textID + ": \"contains\" must have exactly two operands";
						return null;
					}
					String v2 = operands.get(0);
					String v1 = operands.get(1);
					if (v1.contains(v2)) {
						stack.push(SaplN3Constants.TRUE);
					} else {
						stack.push(SaplN3Constants.FALSE);
					}
				} else if (func.equals("indexOf")) {
					if ((operands.size() != 2) && (operands.size() != 3)) {
						this.errorMessage = "Error in " + textID + ": \"indexOf\" must have two or three operands";
						return null;
					}
					Double v3 = 0.0;
					int i = 0;
					if (operands.size() == 3) {
						v3 = dOperands.get(i++);
					}
					String v2 = operands.get(i++);
					String v1 = operands.get(i);

					if (v3 == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be the third operand of \"indexOf\"";
						return null;
					}
					int ind;
					if (operands.size() == 3) {
						ind = (int) v3.doubleValue();
					} else {
						ind = 0;
					}
					int res = v1.indexOf(v2, ind);
					stack.push(this.makeStringValue(res));
				} else if (func.equals("lastIndexOf")) {
					if ((operands.size() != 2) && (operands.size() != 3)) {
						this.errorMessage = "Error in " + textID + ": \"lastIndexOf\" must have two or three operands";
						return null;
					}
					Double v3 = 0.0;
					int i = 0;
					if (operands.size() == 3) {
						v3 = dOperands.get(i++);
					}
					String v2 = operands.get(i++);
					String v1 = operands.get(i);

					if (v3 == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be the third operand of \"lastIndexOf\"";
						return null;
					}
					int ind;
					if (operands.size() == 3) {
						ind = (int) v3.doubleValue();
					} else {
						ind = v1.length();
					}
					int res = v1.lastIndexOf(v2, ind);
					stack.push(this.makeStringValue(res));
				} else if (func.equals("toLowerCase")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"toLowerCase\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					stack.push(v.toLowerCase());
				} else if (func.equals("toUpperCase")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"toUpperCase\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					stack.push(v.toUpperCase());
				} else if (func.equals("getNameSpace")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"getNameSpace\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					if (v.startsWith("<") && v.endsWith(">")) {
						v = v.substring(1, v.length() - 1);
					}
					int ind = v.indexOf("#");
					if (ind == -1) {
						ind = v.lastIndexOf("/");
					}
					if (ind == -1) {
						stack.push("");
					} else {
						stack.push("<" + v.substring(0, ind + 1) + ">");
					}
				} else if (func.equals("getLocalName")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"getLocalName\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					if (v.startsWith("<") && v.endsWith(">")) {
						v = v.substring(1, v.length() - 1);
					}
					int ind = v.indexOf("#");
					if (ind == -1) {
						ind = v.lastIndexOf("/");
					}
					if (ind == -1) {
						stack.push(v);
					} else {
						stack.push(v.substring(ind + 1));
					}
				} else if (func.equals("ID")) {
					if (operands.size() != 0) {
						this.errorMessage = "Error in " + textID + ": \"ID\" must have exactly one operand";
						return null;
					}
					stack.push(ExpressionEvaluator.idgenerator.getNewID());
				}

				//other functions
				else if (func.equals("exists")) {
					if (operands.size() > 1) {
						this.errorMessage = "Error in " + textID + ": \"exists\" must have exactly one operand";
						return null;
					}
					if (operands.size() == 0) {
						stack.push(SaplN3Constants.FALSE);
					} else {
						stack.push(SaplN3Constants.TRUE);
					}
				} else if (func.equals("numberOfMembers")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"numberOfMembers\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					ContextContainer context = myAgent.contexts.get(v);
					if (context == null) {
						this.errorMessage = "Error in " + textID + ": Only a context container ID can be operand of \"numberOfMembers\"";
						return null;
					}
					stack.push(this.makeStringValue(context.members.size()));
				} else if (func.equals("valueOf")) {
					if (operands.size() != 1) {
						this.errorMessage = "Error in " + textID + ": \"valueOf\" must have exactly one operand";
						return null;
					}
					String v = operands.get(0);
					if (v.startsWith("?")) {
						String value = vars.get(v.substring(1));
						if (value == null) {
							this.errorMessage = v + " not bound";
							return null;
						}
						stack.push(value);
					} else {
						this.errorMessage = "Error in " + textID + ": Only a variable name can be operand of \"valueOf\", but \"" + v
								+ "\" found";
						return null;
					}
				} else if (func.equals("timeMillis")) {
					if ((operands.size() != 1) && (operands.size() != 2)) {
						this.errorMessage = "Error in " + textID + ": \"timeMillis\" must have one or two operands";
						return null;
					}
					String v2 = null;
					int i = 0;
					if (operands.size() == 2) {
						v2 = operands.get(i++);
					}
					String v = operands.get(i++);
					if (v2 == null) {
						DatatypeFactory df;
						try {
							df = DatatypeFactory.newInstance();
						} catch (Exception e) {
							e.printStackTrace();
							return null;
						}
						try {
							XMLGregorianCalendar calendar = df.newXMLGregorianCalendar(v);
							stack.push(String.valueOf(calendar.toGregorianCalendar().getTimeInMillis()));
						} catch (IllegalArgumentException e) {
							this.errorMessage = "Error in " + textID
									+ ": Only a valid XMLGregorianCalendar string can be the operand of one-operand \"timeMillis\": found "
									+ v;
							return null;
						}
					} else {
						try {
							SimpleDateFormat sdf = new SimpleDateFormat(v2);
							Date d = sdf.parse(v);
							GregorianCalendar calendar = new GregorianCalendar();
							calendar.setTime(d);
							stack.push(String.valueOf(calendar.getTimeInMillis()));
						} catch (Exception e) {
							this.errorMessage = "Error in " + textID + ": Error when parsing two-operand \"timeMillis\": " + v + " " + v2;
							return null;
						}
					}
				} else if (func.equals("timeString")) {
					if ((operands.size() != 1) && (operands.size() != 2) && (operands.size() != 3)) {
						this.errorMessage = "Error in " + textID + ": \"timeString\" must have one, two or three operands";
						return null;
					}
					String tzone = null;
					String format = null;
					int i = 0;
					String v2 = null;
					String v3 = null;

					if (operands.size() == 3) {
						v3 = operands.get(i++);
					}
					if (operands.size() >= 2) {
						v2 = operands.get(i++);
					}
					Double v = dOperands.get(i++);
					if (v == null) {
						this.errorMessage = "Error in " + textID + ": Only a number can be the first operand of \"timeString\"";
						return null;
					}
					TimeZone timezone = null;
					if (operands.size() > 1) {
						format = v2;
						String[] tzs = TimeZone.getAvailableIDs();
						for (int itz = 0; itz < tzs.length; itz++) {
							if (tzs[itz].equals(v2)) {
								tzone = v2;
								format = v3;
								break;
							}
							if (v3 != null) {
								if (tzs[itz].equals(v3)) {
									tzone = v3;
									format = v2;
									break;
								}
							}
						}
						if ((operands.size() == 3) && (tzone == null)) {
							this.errorMessage = "Error in " + textID + ": Unknown timezone given";
							return null;
						}
						if (tzone != null) {
							timezone = TimeZone.getTimeZone(tzone);
						}
					}

					long time = v.longValue();
					GregorianCalendar gc;
					if (timezone != null) {
						gc = new GregorianCalendar(timezone);
					} else {
						gc = new GregorianCalendar();
					}
					gc.setTimeInMillis(time);
					if (format == null) {
						DatatypeFactory df;
						try {
							df = DatatypeFactory.newInstance();
						} catch (Exception e) {
							e.printStackTrace();
							return null;
						}
						XMLGregorianCalendar calendar = df.newXMLGregorianCalendar(gc);
						stack.push(calendar.toXMLFormat());
					} else {
						try {
							SimpleDateFormat sdf = new SimpleDateFormat(format);
							if (timezone != null) {
								sdf.setTimeZone(timezone);
							}
							String str = sdf.format(gc.getTime());
							stack.push(str);
						} catch (Exception e) {
							this.errorMessage = "Error in " + textID + ": Error when formating in two-operand \"timeString\": " + v + " "
									+ v2;
							return null;
						}
					}
				}
			}

			else {
				if (command.startsWith("\"") && command.endsWith("\"")) {
					command = command.substring(1, command.length() - 1);
				}

				if (command.startsWith("?")) {
					String value = vars.get(command.substring(1));
					if (value != null) {
						stack.push(value);
					} else {
						this.errorMessage = command + " not bound";
						return null;
					}
				} else {
					stack.push(command);
				}

			}
		}
		if (!stack.isEmpty()) {
			return stack.pop();
		} else {
			return null;
		}
	}

}