package ubiware.core;

public class LinkInfo {
	public String contextID;
	public String statementID;

	public LinkInfo(String contextID, String statementID) {
		this.contextID = contextID;
		this.statementID = statementID;
	}

	@Override
	public String toString() {
		return this.contextID + "->" + this.statementID;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((this.contextID == null) ? 0 : this.contextID.hashCode());
		result = (prime * result) + ((this.statementID == null) ? 0 : this.statementID.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof LinkInfo)) {
			return false;
		}
		LinkInfo other = (LinkInfo) obj;
		if (this.contextID == null) {
			if (other.contextID != null) {
				return false;
			}
		} else if (!this.contextID.equals(other.contextID)) {
			return false;
		}
		if (this.statementID == null) {
			if (other.statementID != null) {
				return false;
			}
		} else if (!this.statementID.equals(other.statementID)) {
			return false;
		}
		return true;
	}

	//	@Override
	//	public int hashCode() {
	//		return this.toString().hashCode();
	//	}

}
