package ubiware.core;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Stack;

import ubiware.util.StringEscape;

public class SaplN3 {

	private static final String a[][] = new String[SaplN3.uCount][SaplN3.tCount];
	private static final int tCount = 11;
	private static final char t[] = new char[SaplN3.tCount];
	private static final int uCount = 11;

	private static final String error[] = new String[4];

	static {
		/*
		// This is a nice version of the table below

		t[0]='?';			t[1]='{';			t[2]='}';		t[3]='.';		t[4]=';';		t[5]=',';		t[6] = '[';			t[7] = ']';		t[8] = '(';			t[9] = ')';		t[10]='#';
			
		a[0][0]="B#";		a[0][1]="B#";		a[0][2]="$3";	a[0][3]="$3";	a[0][4]="$3";	a[0][5]="$3";	a[0][6]="B#"; 		a[0][7]="$3"; 	a[0][8]="B#";		a[0][9]="$3";	a[0][10]="_"; 	//A: Program
		a[1][0]="DaC";		a[1][1]="DaC";		a[1][2]="_";	a[1][3]="$3";	a[1][4]="$3";	a[1][5]="$3";	a[1][6]="DaC"; 		a[1][7]="$3"; 	a[1][8]="DaC";		a[1][9]="$3";	a[1][10]="_"; 	//B: StatementList
		a[2][0]="";			a[2][1]="";			a[2][2]="_";	a[2][3]=".B";	a[2][4]="";		a[2][5]="";		a[2][6]=""; 		a[2][7]="$3"; 	a[2][8]="";			a[2][9]="$3";	a[2][10]="_";	//C: StatementListTail
		a[3][0]="EF";		a[3][1]="EF";		a[3][2]="$3";	a[3][3]="$3";	a[3][4]="$3";	a[3][5]="$3";	a[3][6]="EF"; 		a[3][7]="$3"; 	a[3][8]="EF";		a[3][9]="$3";	a[3][10]="$3";	//D: SameSubjectStatements
		a[4][0]="?";		a[4][1]="{dB}e";	a[4][2]="$3";	a[4][3]="$3";	a[4][4]="$3";	a[4][5]="$3";	a[4][6]="[fF]b";	a[4][7]="$3"; 	a[4][8]="(flhEbK)jka";a[4][9]="$3";	a[4][10]="$3";	//E: Subject
		a[5][0]="JIHG";		a[5][1]="$0";		a[5][2]="$0";	a[5][3]="$0";	a[5][4]="$0";	a[5][5]="$0";	a[5][6]="$0"; 		a[5][7]="$0"; 	a[5][8]="$0";		a[5][9]="$0";	a[5][10]="$0";	//F: PropertyList
		a[6][0]="$2";		a[6][1]="$2";		a[6][2]="_";	a[6][3]="_";	a[6][4]=";bF";	a[6][5]="";		a[6][6]="$2"; 		a[6][7]="_"; 	a[6][8]="$2";		a[6][9]="";		a[6][10]="_";	//G: PropertyListTail
		a[7][0]="$2";		a[7][1]="$2";		a[7][2]="_";	a[7][3]="_";	a[7][4]="_";	a[7][5]=",cIH";	a[7][6]="$2"; 		a[7][7]="_"; 	a[7][8]="$2";		a[7][9]="";		a[7][10]="_";	//H: ObjectTail
		a[8][0]="?";		a[8][1]="{dB}e";	a[8][2]="$1";	a[8][3]="$1";	a[8][4]="$1";	a[8][5]="$1";	a[8][6]="[fiF]";	a[8][7]="$1"; 	a[8][8]="(flhEbK)jka";	a[8][9]="$1";	a[8][10]="$1";	//I: Object
		a[9][0]="?";		a[9][1]="$0";		a[9][2]="$0";	a[9][3]="$0";	a[9][4]="$0";	a[9][5]="$0";	a[9][6]="$0"; 		a[9][7]="$0"; 	a[9][8]="$0";		a[9][9]="$0";	a[9][10]="$0";	//J: Predicate
		a[10][0]="jfihEbK";	a[10][1]="jfihEbK";	a[10][2]="$1";	a[10][3]="$1";	a[10][4]="$1";	a[10][5]="$1";	a[10][6]="jfihEbK";	a[10][7]="$1"; 	a[10][8]="jfihEbK";	a[10][9]="_";	a[10][10]="$1";	//K: ResourceListTail
		*/

		SaplN3.t[0] = '?';
		SaplN3.t[1] = '{';
		SaplN3.t[2] = '}';
		SaplN3.t[3] = '.';
		SaplN3.t[4] = ';';
		SaplN3.t[5] = ',';
		SaplN3.t[6] = '[';
		SaplN3.t[7] = ']';
		SaplN3.t[8] = '(';
		SaplN3.t[9] = ')';
		SaplN3.t[10] = '#';

		SaplN3.a[0][0] = "B#";
		SaplN3.a[0][1] = "B#";
		SaplN3.a[0][2] = "$3";
		SaplN3.a[0][3] = "$3";
		SaplN3.a[0][4] = "$3";
		SaplN3.a[0][5] = "$3";
		SaplN3.a[0][6] = "B#";
		SaplN3.a[0][7] = "$3";
		SaplN3.a[0][8] = "B#";
		SaplN3.a[0][9] = "$3";
		SaplN3.a[0][10] = "_"; //A: Program
		SaplN3.a[1][0] = "DaC";
		SaplN3.a[1][1] = "DaC";
		SaplN3.a[1][2] = "_";
		SaplN3.a[1][3] = "$3";
		SaplN3.a[1][4] = "$3";
		SaplN3.a[1][5] = "$3";
		SaplN3.a[1][6] = "DaC";
		SaplN3.a[1][7] = "$3";
		SaplN3.a[1][8] = "DaC";
		SaplN3.a[1][9] = "$3";
		SaplN3.a[1][10] = "_"; //B: StatementList
		SaplN3.a[2][0] = "";
		SaplN3.a[2][1] = "";
		SaplN3.a[2][2] = "_";
		SaplN3.a[2][3] = ".B";
		SaplN3.a[2][4] = "";
		SaplN3.a[2][5] = "";
		SaplN3.a[2][6] = "";
		SaplN3.a[2][7] = "$3";
		SaplN3.a[2][8] = "";
		SaplN3.a[2][9] = "$3";
		SaplN3.a[2][10] = "_"; //C: StatementListTail
		SaplN3.a[3][0] = "EF";
		SaplN3.a[3][1] = "EF";
		SaplN3.a[3][2] = "$3";
		SaplN3.a[3][3] = "$3";
		SaplN3.a[3][4] = "$3";
		SaplN3.a[3][5] = "$3";
		SaplN3.a[3][6] = "EF";
		SaplN3.a[3][7] = "$3";
		SaplN3.a[3][8] = "EF";
		SaplN3.a[3][9] = "$3";
		SaplN3.a[3][10] = "$3"; //D: SameSubjectStatements
		SaplN3.a[4][0] = "?";
		SaplN3.a[4][1] = "{dB}e";
		SaplN3.a[4][2] = "$3";
		SaplN3.a[4][3] = "$3";
		SaplN3.a[4][4] = "$3";
		SaplN3.a[4][5] = "$3";
		SaplN3.a[4][6] = "[fF]b";
		SaplN3.a[4][7] = "$3";
		SaplN3.a[4][8] = "(flhEbK)jka";
		SaplN3.a[4][9] = "$3";
		SaplN3.a[4][10] = "$3"; //E: Subject
		SaplN3.a[5][0] = "JIHG";
		SaplN3.a[5][1] = "$0";
		SaplN3.a[5][2] = "$0";
		SaplN3.a[5][3] = "$0";
		SaplN3.a[5][4] = "$0";
		SaplN3.a[5][5] = "$0";
		SaplN3.a[5][6] = "$0";
		SaplN3.a[5][7] = "$0";
		SaplN3.a[5][8] = "$0";
		SaplN3.a[5][9] = "$0";
		SaplN3.a[5][10] = "$0"; //F: PropertyList
		SaplN3.a[6][0] = "$2";
		SaplN3.a[6][1] = "$2";
		SaplN3.a[6][2] = "_";
		SaplN3.a[6][3] = "_";
		SaplN3.a[6][4] = ";bF";
		SaplN3.a[6][5] = "";
		SaplN3.a[6][6] = "$2";
		SaplN3.a[6][7] = "_";
		SaplN3.a[6][8] = "$2";
		SaplN3.a[6][9] = "";
		SaplN3.a[6][10] = "_"; //G: PropertyListTail
		SaplN3.a[7][0] = "$2";
		SaplN3.a[7][1] = "$2";
		SaplN3.a[7][2] = "_";
		SaplN3.a[7][3] = "_";
		SaplN3.a[7][4] = "_";
		SaplN3.a[7][5] = ",cIH";
		SaplN3.a[7][6] = "$2";
		SaplN3.a[7][7] = "_";
		SaplN3.a[7][8] = "$2";
		SaplN3.a[7][9] = "";
		SaplN3.a[7][10] = "_"; //H: ObjectTail
		SaplN3.a[8][0] = "?";
		SaplN3.a[8][1] = "{dB}e";
		SaplN3.a[8][2] = "$1";
		SaplN3.a[8][3] = "$1";
		SaplN3.a[8][4] = "$1";
		SaplN3.a[8][5] = "$1";
		SaplN3.a[8][6] = "[fiF]";
		SaplN3.a[8][7] = "$1";
		SaplN3.a[8][8] = "(flhEbK)jka";
		SaplN3.a[8][9] = "$1";
		SaplN3.a[8][10] = "$1"; //I: Object
		SaplN3.a[9][0] = "?";
		SaplN3.a[9][1] = "$0";
		SaplN3.a[9][2] = "$0";
		SaplN3.a[9][3] = "$0";
		SaplN3.a[9][4] = "$0";
		SaplN3.a[9][5] = "$0";
		SaplN3.a[9][6] = "$0";
		SaplN3.a[9][7] = "$0";
		SaplN3.a[9][8] = "$0";
		SaplN3.a[9][9] = "$0";
		SaplN3.a[9][10] = "$0"; //J: Predicate
		SaplN3.a[10][0] = "jfihEbK";
		SaplN3.a[10][1] = "jfihEbK";
		SaplN3.a[10][2] = "$1";
		SaplN3.a[10][3] = "$1";
		SaplN3.a[10][4] = "$1";
		SaplN3.a[10][5] = "$1";
		SaplN3.a[10][6] = "jfihEbK";
		SaplN3.a[10][7] = "$1";
		SaplN3.a[10][8] = "jfihEbK";
		SaplN3.a[10][9] = "_";
		SaplN3.a[10][10] = "$1"; //K: ResourceListTail

		SaplN3.error[0] = "A value (predicate) is expected but ";
		SaplN3.error[1] = "A value (object), [ , ( or { is expected but ";
		SaplN3.error[2] = "The statement is finalized but additional ";
		SaplN3.error[3] = "A value (subject), [ or { is expected but ";
	}

	private static final Map<String, String> replace = SaplN3.createReplaceMap();

	static Map<String, String> createReplaceMap() {
		Map<String, String> replaceMap = new HashMap<String, String>();
		//replaceMap = new HashMap<String, String>();
		replaceMap.put("a", "<" + UbiwareAgent.RDF_NS + "type>");

		replaceMap.put("=>", SaplN3Constants.implies);
		replaceMap.put(">>", SaplN3Constants.achievedBy);
		replaceMap.put("->", SaplN3Constants.impliesNow);
		replaceMap.put("==>", SaplN3Constants.infers);

		replaceMap.put(">", SaplN3Constants.gt);
		replaceMap.put("<", SaplN3Constants.lt);
		replaceMap.put(">=", SaplN3Constants.gte);
		replaceMap.put("<=", SaplN3Constants.lte);
		replaceMap.put("!=", SaplN3Constants.neq);
		replaceMap.put("=", SaplN3Constants.eq);
		return Collections.unmodifiableMap(replaceMap);
	}

	//	UbiwareAgent myAgent;

	/**
	 * This compiler class has been made completely static by Michael COchez Reason: There was absolutely no reason why the class had to be
	 * instantiated each time the compiler was needed. The class instances used to hold a reference to an agent just in case someone would
	 * like to generate Sapl Then there were instance attributes in use for use in recursive method calls. Constructor is made private to
	 * avoid confusion
	 */
	private SaplN3() {
		//		this.myAgent = agent;
	}

	private static void print(String string) {
		//this.myAgent.print(string);
		//FIXME this used to be piped to the agent for nicer output! Now straight to stderr should this go back? The print is only used for Warnings/errors! 
		System.err.println(string);
	}

	/*Parsing S-APL N3*/

	public static List<String> compileFile(String filename) throws IOException {
		File datafile = new File(filename);
		int len = (int) datafile.length();
		char mess[] = new char[len];
		//InputStreamReader iread = ;
		BufferedReader ff = null;
		int read = 0;
		try {
			ff = new BufferedReader(new FileReader(datafile));
			read = ff.read(mess, 0, len);
		} finally {
			if (ff != null) {
				try {
					ff.close();
				} catch (IOException e) {
					// not much we can do here!
				}
			}
		}
		String text = new String(mess, 0, read);
		return SaplN3.compile(text, filename);
	}

	public static List<String> compile(String text, String textID) {
		int sz = Math.min(100, text.length() / 10);
		List<String> tokens = new ArrayList<String>(sz);
		StringBuilder lexStringBuilder = new StringBuilder(sz);

		SaplN3.lexicalAnalysis(text, tokens, lexStringBuilder);

		//System.out.println(tokens);
		//System.out.println(lexStringBuilder);

		List<String> code = new ArrayList<String>(sz);

		if ((lexStringBuilder.length() > 0) && SaplN3.syntaxAnalysis(tokens, lexStringBuilder.toString(), code, textID, text)) {
			//System.out.println(code);
			return code;
		} else {
			return null;
		}
	}

	private static void lexicalAnalysis(String text, List<String> tokens, StringBuilder lexStringBuilder) {
		boolean inside_literal = false;
		boolean inside_comment = false;
		boolean comment_is_line = false;
		boolean inside_uri = false;

		int len = text.length();
		int tokS = 0;
		for (int c = 0; c < len; c++) {
			char ch = text.charAt(c);
			if (ch == '\n') {
				inside_uri = false;
				if (!inside_comment && !inside_literal) {
					if (tokS != c) {
						tokens.add(text.substring(tokS, c));
						lexStringBuilder.append('?');
					}
					tokS = c + 1;
				} else if (inside_comment && comment_is_line) {
					inside_comment = false;
					tokS = c + 1;
				}

				tokens.add(" "); //to count lines
				lexStringBuilder.append(' '); //to count lines
			} else if (!inside_comment && (ch == '"') && ((c == 0) || (text.charAt(c - 1) != '\\'))) {
				if (!inside_literal) {
					inside_literal = true;
				} else {
					inside_literal = false;
					inside_uri = false;
				}
			} else if (ch == '<') {
				inside_uri = true;
			} else if (ch == '>') {
				inside_uri = false;
			} else if (!inside_literal && !inside_comment && ((c + 1) < len) && (ch == '/')) {
				if ((text.charAt(c + 1) == '*') || (!inside_uri && (text.charAt(c + 1) == '/'))) {
					if (tokS != c) {
						tokens.add(text.substring(tokS, c));
						lexStringBuilder.append('?');
					}
					inside_comment = true;
					if (text.charAt(c + 1) == '/') {
						comment_is_line = true;
					} else {
						comment_is_line = false;
					}
					c++;
				}
			} else if (inside_comment && !comment_is_line && ((c + 1) < len) && (ch == '*') && (text.charAt(c + 1) == '/')) {
				inside_comment = false;
				tokS = c + 2;
				c++;
			} else if (!inside_comment && !inside_literal && Character.isWhitespace(ch)) {
				inside_uri = false;
				if (tokS != c) {
					tokens.add(text.substring(tokS, c));
					lexStringBuilder.append('?');
				}
				tokS = c + 1;
			} else if (!inside_comment
					&& !inside_literal
					&& ((ch == '{') || (ch == '}') || (ch == '[') || (ch == ']') || (ch == '(') || (ch == ')') || (((ch == '.')
							|| (ch == ';') || (ch == ','))
							&& ((c + 1) < len) && Character.isWhitespace(text.charAt(c + 1))))) {
				if (tokS != c) {
					tokens.add(text.substring(tokS, c));
					lexStringBuilder.append('?');
				}
				tokens.add("" + ch);
				lexStringBuilder.append(ch);
				tokS = c + 1;
			}
		}
		if (!inside_comment && (tokS < len)) {
			String rest = text.substring(tokS, len);
			tokens.add(rest);
			lexStringBuilder.append('?');
		}
	}

	private static boolean syntaxAnalysis(List<String> tokens, String lexString, List<String> code, String textID, String originalText) {
		lexString += '#';
		StringBuilder curString = new StringBuilder(100);
		curString.append('A');
		int iLex = 0;
		int iCur = 0;
		int currLineNumber = 1;

		while (true) {
			while ((curString.charAt(iCur) >= 'a') && (curString.charAt(iCur) <= 'z')) {
				code.add("{@$@}" + curString.charAt(iCur));
				iCur++;
			}
			while (lexString.charAt(iLex) == ' ') {
				currLineNumber++;
				iLex++;
			}

			char ch = curString.charAt(iCur);
			char lex_ch = lexString.charAt(iLex);
			if (ch == lex_ch) {
				if (ch == '#') {
					return true;
				} else if (ch == '?') {
					String token = tokens.get(iLex);
					if (token.startsWith("{@$@}") || token.startsWith(UbiwareAgent.CONTEXT_PREFIX)
							|| token.startsWith(UbiwareAgent.QUERY_CONTEXT_PREFIX) || token.startsWith(UbiwareAgent.STATEMENT_PREFIX)) {
						String errorMessgae = "Syntax Error in " + textID + ":" + String.valueOf(currLineNumber) + ": Illegal value "
								+ token + "\n";
						SaplN3.print(errorMessgae);
						try {
							throw new Error("Syntax Error in " + textID + ":" + String.valueOf(currLineNumber) + ": Illegal value " + token
									+ "\n" + "text was" + originalText);
						} catch (Error e) {
							e.printStackTrace();
						}
						return false;
					}
					code.add(token);
				}
				iCur++;
				iLex++;
			} else {
				int iy = ch - 'A';
				if ((iy < 0) || (iy > SaplN3.uCount)) {
					String found;
					if (lex_ch == '?') {
						found = "Value (" + tokens.get(iLex) + ")";
					} else if (lex_ch == '#') {
						found = "End of text";
					} else {
						found = "" + lex_ch;
					}
					String expected;
					if (ch == '#') {
						expected = "End of text";
					} else {
						expected = "" + ch;
					}
					SaplN3.print("Syntax Error in " + textID + ":" + String.valueOf(currLineNumber) + ": " + expected + " is expected but "
							+ found + " is found\n");
					try {
						throw new Error("Syntax Error in " + textID + ":" + String.valueOf(currLineNumber) + ": " + expected
								+ " is expected but " + found + " is found\n" + "text was" + originalText);
					} catch (Error e) {
						e.printStackTrace();
					}

					return false;
				}
				int ix = -1;
				for (int i = 0; i < SaplN3.tCount; i++) {
					if (SaplN3.t[i] == lex_ch) {
						ix = i;
						break;
					}
				}

				String fromTable = SaplN3.a[iy][ix];

				if (fromTable.equals("") || fromTable.startsWith("$")) {
					String err = "";
					if (fromTable.startsWith("$")) {
						int ind = Integer.valueOf(fromTable.substring(1));
						err = SaplN3.error[ind];
					}
					String found;
					if (lex_ch == '?') {
						found = "Value (" + tokens.get(iLex) + ")";
					} else if (lex_ch == '#') {
						found = "End of text";
					} else {
						found = "" + lex_ch;
					}

					SaplN3.print("Syntax Error in " + textID + ":" + String.valueOf(currLineNumber) + ": " + err + found + " is found\n");
					try {
						throw new Error("Syntax Error in " + textID + ":" + String.valueOf(currLineNumber) + ": " + err + found
								+ " is found\n" + "text was\n" + originalText + "\n");
					} catch (Error e) {
						e.printStackTrace();
					}
					return false;
				} else if (fromTable.equals("_")) {
					curString.deleteCharAt(iCur);
				} else {
					curString.replace(iCur, iCur + 1, fromTable);
				}

			}
		}
	}

	private static String fixResource(String resource, HashMap<String, String> namespaces, String textID) {
		resource = StringEscape.unEscape(resource);
		if (resource.startsWith("\"") && resource.endsWith("\"")) {
			return resource.substring(1, resource.length() - 1);
		} else if (!resource.startsWith("<") || !resource.endsWith(">")) {
			int ind = resource.indexOf(":");
			if (ind >= 0) {
				String ns = resource.substring(0, ind + 1);
				if (!ns.equals("_:") && !ns.equals("http:")) {
					String uri = namespaces.get(ns);
					if (uri == null) {
						if (ind == 0) {
							return "<#" + resource.substring(1) + ">";
						} else {
							SaplN3.print("Warning in " + textID + ": Undefined namespace " + ns + "\n");
						}
					} else {
						return "<" + uri + resource.substring(ind + 1) + ">";
					}
				} else {
					resource = "<" + resource + ">";
				}
			}
		}
		return resource;
	}

	public static void load(List<String> code, UbiwareAgent targetAgent, String topContext, String textID, boolean doJoinCheck) {

		if (targetAgent.contexts.get(topContext) == null) {
			targetAgent.print("Error in beliefs load: context " + topContext + " does not exist\n");
			return;
		}

		targetAgent.clearLocalIDs();

		Stack<String> stack = new Stack<String>();
		Stack<String> statementsStack = new Stack<String>();

		HashMap<String, String> namespaces = new HashMap<String, String>();
		namespaces.put(":", "#");

		String bnNameBase = UbiwareAgent.BLANK_NODE_NS + targetAgent.getLocalName() + String.valueOf(System.currentTimeMillis()) + "_";
		int bnCount = 0;

		for (String command : code) {
			//<String> it = code.iterator();
			//while (it.hasNext()) {
			//	String command = it.next();

			if (command.equals("{@$@}a") || command.equals("{@$@}b") || command.equals("{@$@}c") || command.equals("{@$@}i")) { //statement is made
				String object = stack.pop();
				String predicate = stack.pop();
				String subject = stack.pop();

				String objectDatatype = null;
				String objectLanguage = null;

				if (subject.equals("@prefix")) { //namespace is defined
					if ((object.startsWith("\"") && object.endsWith("\"")) || (object.startsWith("<") && object.endsWith(">"))) {
						object = object.substring(1, object.length() - 1);
					}
					namespaces.put(predicate, object);
				} else {
					subject = SaplN3.fixResource(subject, namespaces, textID);
					predicate = SaplN3.fixResource(predicate, namespaces, textID);
					String match = SaplN3.replace.get(predicate);
					if (match != null) {
						predicate = match;
					}

					if (object.startsWith("\"") && !object.endsWith("\"")) {
						int ind = object.indexOf("\"^^");
						if (ind > 0) {
							objectDatatype = object.substring(ind + 3);
							object = SaplN3.fixResource(object.substring(0, ind + 1), namespaces, textID);
							objectDatatype = SaplN3.fixResource(objectDatatype, namespaces, textID);
						} else {
							ind = object.indexOf("\"@");
							if (ind > 0) {
								objectLanguage = object.substring(ind + 2);
								object = object.substring(1, ind);
							}
						}
					} else {
						object = SaplN3.fixResource(object, namespaces, textID);
					}

					String id = targetAgent.statementIDGenerator.getNewStatementID();//UbiwareAgent.STATEMENT_PREFIX + String.valueOf(++targetAgent.statementCount);
					SemanticStatement st = new SemanticStatement(subject, predicate, object, objectDatatype, objectLanguage);
					targetAgent.putBelief(id, st);

					statementsStack.push(id);

					//myAgent.print(st);
				}

				if (command.equals("{@$@}b") || command.equals("{@$@}c")) {
					String cid = subject;
					if (subject.startsWith(UbiwareAgent.CONTEXT_PREFIX)) {
						subject = targetAgent.contextIDGenerator.getNewContextID();//  UbiwareAgent.CONTEXT_PREFIX + String.valueOf(++targetAgent.contextCount);
						targetAgent.putContext(subject, cid);
					}
					stack.push(subject);
					if (command.equals("{@$@}c")) {
						stack.push(predicate);
					}
				} else if (command.equals("{@$@}i")) {
					stack.push(object);
				}
			} else if (command.equals("{@$@}d")) {//beginning of context
				statementsStack.push("{@$@}");
			} else if (command.equals("{@$@}e")) {//end of context

				List<String> statements = new ArrayList<String>();
				while (true) {
					String statementID = statementsStack.pop();
					if (statementID.equals("{@$@}")) {
						break;
					} else {
						statements.add(statementID);
					}
				}

				String id = targetAgent.contextIDGenerator.getNewContextID();// UbiwareAgent.CONTEXT_PREFIX + String.valueOf(++targetAgent.contextCount);
				if (statements.size() > 10) {
					targetAgent.putContext(id, statements.size());
				} else {
					targetAgent.putContext(id);
				}

				for (int i = statements.size() - 1; i >= 0; i--) {
					targetAgent.putLink(id, statements.get(i), doJoinCheck);
				}
				stack.push(id);
			} else if (command.equals("{@$@}f")) {//creation of anonimous node
				String bnID = bnNameBase + String.valueOf(++bnCount);
				stack.push(bnID);
			} else if (command.equals("{@$@}l")) { //copy previous resource
				String object = stack.peek();
				stack.push(object);
			} else if (command.equals("{@$@}h")) {//push rdf:first
				stack.push("<" + UbiwareAgent.RDF_NS + "first>");
			} else if (command.equals("{@$@}j")) {//push rdf:rest
				stack.push("<" + UbiwareAgent.RDF_NS + "rest>");
			} else if (command.equals("{@$@}k")) {//push rdf:nil
				stack.push("<" + UbiwareAgent.RDF_NS + "nil>");
			} else {
				stack.push(command);
			}
		}

		List<String> statements = new ArrayList<String>();
		while (!statementsStack.empty()) {
			statements.add(statementsStack.pop());
		}

		for (int i = statements.size() - 1; i >= 0; i--) {
			targetAgent.putLink(topContext, statements.get(i), doJoinCheck);
		}

		targetAgent.clearLocalIDs();
		targetAgent.addNameSpaces(namespaces);
	}

	/**
	 * Generation of S-APL N3 from the agent's beliefs.
	 * 
	 * @param contextID
	 *            The context ID of the context from which the S-APL N3 should be generated.
	 * @param options
	 *            The options for the production. See {@link ProduceN3Options} for documentation.
	 * @param agent
	 *            The {@link UbiwareAgent} from which the S-APL N3 gets generated.
	 * @return A string containing the S-APL N3 code.
	 */
	public static String produceN3(String contextID, ProduceN3Options options, UbiwareAgent agent) {
		//The actual production is forwarded to a SpalN3Producer
		SaplN3Producer producer = new SaplN3Producer(agent, agent.getResourcePrefixer(), options);
		return producer.produceN3(agent.contexts.get(contextID));
	}

	public static StringBuilder produceN3(String contextID, ProduceN3Options options, UbiwareAgent agent, StringBuilder builder) {
		//The actual production is forwarded to a SpalN3Producer
		SaplN3Producer producer = new SaplN3Producer(agent, agent.getResourcePrefixer(), options);
		return producer.produceN3(agent.contexts.get(contextID), builder);
	}
}