package ubiware.core.behaviors;

import java.io.File;
import java.util.HashMap;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.param;

public class RABRepositoryLookupBehavior extends ReusableAtomicBehavior {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String search;
	private String contextID;

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		// TODO Auto-generated method stub
		this.search = parameters.getParameterValue(param.search);
		this.contextID = parameters.getParameterValue(param.resultTo);

	}

	@Override
	public void doAction() {

		if (this.search == null) {
			this.print(this.getClass().getName() + " error: Mandatory parameter \"search\" is not given");
			this.setFailed();
			return;
		}
		if (this.contextID == null) {
			this.print(this.getClass().getName() + " error: Mandatory parameter \"resultTo\" is not given");
			this.setFailed();
			return;
		}

		String result_name = "DB/_rabs/" + this.search;
		String result_ext = ".class";

		File datafile = new File(result_name + result_ext);
		if (!datafile.exists()) {
			result_ext = ".zip";
			datafile = new File(result_name + result_ext);
			if (!datafile.exists()) {
				this.setFailed();
				return;
			}
		}

		HashMap<String, String> vars = new HashMap<String, String>();
		vars.put("file", result_name + result_ext);
		vars.put("type", result_ext);
		this.addBeliefs(this.contextID, vars);
		this.wakeAgent();
	}
}
