package ubiware.core.behaviors.creation;

import java.util.HashSet;
import java.util.Set;

import ubiware.core.UbiwareAgent;
import ubiware.core.policies.AllowAllPolicyChecker;
import ubiware.core.policies.PolicyChecker;
import ubiware.util.URITools;
import ubiware.util.UniqueInstanceGenerator;
import ubiware.util.saplbuilder.Resource;

public class CreateInfraAgentBehavior extends AbstractDefaultAgentCreationBehavior {
	private static final long serialVersionUID = 1L;
	private static final UniqueInstanceGenerator instanceGenerator = new UniqueInstanceGenerator("Infrastructural",
			URITools.createUncheckedURI("http://www.ubiware.jyu.fi/agents/infrastructure/"));

	@Override
	protected Resource getNewAgentName() {
		return CreateInfraAgentBehavior.instanceGenerator.getNewResource();
	}

	@Override
	protected Set<String> getAgentZones() {
		Set<String> zones = new HashSet<String>(); //since the policy checker is allow all, we don't need any zones.
		zones.add(AgentTypes.Infra);
		return zones;
	}

	@Override
	protected PolicyChecker getPolicyChecker(UbiwareAgent newAgent) {
		return AllowAllPolicyChecker.getInstance();
	}

}
