package ubiware.core.behaviors.creation;

import java.util.HashSet;
import java.util.Set;

import ubiware.core.UbiwareAgent;
import ubiware.core.policies.PUAPolicychecker;
import ubiware.core.policies.PolicyChecker;
import ubiware.core.policies.SafeActionsPolicyChecker;
import ubiware.util.URITools;
import ubiware.util.UniqueInstanceGenerator;
import ubiware.util.saplbuilder.Resource;

public class CreatePUABehavior extends AbstractDefaultAgentCreationBehavior {

	private static final long serialVersionUID = 1L;
	private static final UniqueInstanceGenerator instanceGenerator = new UniqueInstanceGenerator("PUA",
			URITools.createUncheckedURI("http://www.ubiware.jyu.fi/agents/PUA/"));

	//private String name;

	/**
	 * override the scripts by setting it to those
	 */
	@Override
	protected Set<String> getAgentScripts() {
		// TODO Auto-generated method stub
		Set<String> scripts = new HashSet<String>(4);
		//FIXME add right scripts.
		scripts.add("DB/Infrastructure/personalUserAgent/PUA.sapl");
		scripts.add("DB/_ontology/Communication/Action.sapl");
		scripts.add("DB/_ontology/Persistency/PersistencyActions.sapl");
		//	scripts.add("test/AgentPool.sapl");
		//	scripts.add("test/AgentPoolTester.sapl");
		return scripts;
	}

	@Override
	protected PolicyChecker getPolicyChecker(UbiwareAgent newAgent) {
		return new SafeActionsPolicyChecker(this.getAgentName(), new PUAPolicychecker(this.getAgentName()));
	}

	@Override
	protected Set<String> getAgentZones() {
		Set<String> zones = new HashSet<String>();
		//TODO make field
		zones.add(AgentTypes.PUA);
		return zones;
	}

	@Override
	protected Resource getNewAgentName() {
		return CreatePUABehavior.instanceGenerator.getNewResource();
	}

}
