package ubiware.core.visualizer;

/**
 * <p>
 * A class which models the concept of functors (C++) or function (functional programming), processes (Ruby), etc.
 * </p>
 * 
 * @param _Return_T
 *            the return type of this function
 * @author Nikos Mouchtaris
 */
public interface Lambda<_Return_T> {
	/**
	 * Executes this function and returns its result.
	 * 
	 * @param args
	 *            the arguments for the function
	 * @return the result of the function
	 */
	_Return_T call(final Object... args);
}
