package ubiware.infrastructure.ontologyAgent;

import java.io.File;
import java.io.FileWriter;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.param;
import ubiware.util.StreamingUtils;

public class RoleCopyBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;
	private String storage;
	private String roleName;
	private String rolePath;

	@Override
	protected void doAction() {
		try {
			String roleDst = this.storage + "/" + this.roleName.replaceAll("\\.", "/") + ".sapl";
			System.out.println("roleDst: " + roleDst);
			File fileDest = new File(roleDst);
			System.out.println("abs: " + fileDest.getAbsolutePath());
			if (fileDest.exists()) {
				System.err.println("Role " + fileDest.getAbsolutePath() + " already exists");
			}
			//this.setFailed();
			//return;
			//} else {
			// if the parent folder doesn't exist, then create it
			if (!fileDest.getParentFile().exists()) {
				if (!fileDest.getParentFile().mkdirs()) {
					System.err.println("Cannot create file structure " + fileDest.getAbsolutePath());
					this.setFailed();
					return;
				}
			}
			//}

			FileWriter fw = new FileWriter(fileDest);
			fw.write(StreamingUtils.getInputFromFile(new File(this.rolePath)));
			/*
			BufferedReader br = new BufferedReader(new FileReader(this.rolePath));
			String line = null;
			while ((line = br.readLine()) != null) {
				bw.append('\n');
			}
			br.close();
			*/
			System.out.println("....DONE " + File.separatorChar);
			fw.close();
//			UbiwareAgentCommand<Boolean> command = new AddBeliefsN3Command("<http://www.ubiware.jyu.fi/sapl#I> :load {\"" + roleDst
//					+ "\" :file \".sapl\"}");
//			this.myAgent.addCommand(command);
			String sapl = "<http://www.ubiware.jyu.fi/sapl#I> :load {\"" + roleDst	+ "\" :file \".sapl\"}";
			this.addBeliefsN3(sapl);
		} catch (Exception e) {
			e.printStackTrace();
			this.setFailed();
			return;
		}

	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.storage = parameters.getObligatedNonEmptyStringParameter(param.storage);
		this.roleName = parameters.getObligatedNonEmptyStringParameter(param.roleName);
		this.rolePath = parameters.getObligatedNonEmptyStringParameter(param.rolePath);
	}

}
