package ubiware.infrastructure.packageManager;

import java.io.File;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.param;

public class FileCheckerBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;
	private int timeInterval;
	private String folder;

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.timeInterval = parameters.getObligatedNumericParameter(param.timeInterval);
		this.folder = parameters.getObligatedStringParameter(param.folder);
		//Resource r = parameters.getObligatedResourceParameter(param.gfg");
	}

	@Override
	protected void doAction() {
		System.out.println("timeInterval = " + this.timeInterval);
		System.out.println("folder = " + this.folder);
		File folderToCheck = new File(this.folder);
		if (folderToCheck.isDirectory() && folderToCheck.exists()) {
			this.myAgent.addBehaviour(new FileCheckerTickBehavior(this.myAgent, this.timeInterval, folderToCheck));
			return;
		} else {
			System.err.println("The folder " + folderToCheck
					+ " doesn't exist. Stoping behavior ubiware.infrastructure.packageManager.FileCheckerBehavior");
			this.setFailed();
			return;
		}
	}
}
