package ubiware.infrastructure.ubiwareDF;

import jade.core.AID;
import jade.lang.acl.ACLMessage;

import java.util.Set;

import ubiware.core.UbiwareAgent;
import ubiware.util.saplbuilder.Resource;

public class NameInformingSPL implements ServiceProviderListener {
	private String receiver;
	private UbiwareAgent myAgent;
	private String conversationID;
	private static final Resource provides = Resource
			.createUncheckedResource("<http://www.ubiware.jyu.fi/directoryFacilitator#providesService>");

	//private final static URI messageNamespace = URITools
	//		.createUncheckedURI("http://www.ubiware.jyu.fi/directoryFacilitator/messages/send/");

	//private final static UniqueInstanceGenerator messageInstanceGenerator = new UniqueInstanceGenerator("",
	//		InformingServiceProviderListener.messageNamespace);

	//	public InformingServiceProviderListener(Agent receiver, UbiwareAgent myAgent) {
	//		this(receiver, myAgent, InformingServiceProviderListener.messageInstanceGenerator.getNewResource());
	//	}

	public NameInformingSPL(Agent receiver, UbiwareAgent myAgent, Resource conversationID) {
		super();
		this.receiver = receiver.getAgentAsResource().toString();
		this.myAgent = myAgent;
		this.conversationID = conversationID.toString();
	}

	@Override
	public void serviceProviderListChanged(Service service, Set<Agent> agentsProvidingThisService) {
		ACLMessage message = new ACLMessage(ACLMessage.INFORM);
		message.addReceiver(new AID(this.receiver, AID.ISLOCALNAME));
		//SaplDocument document = new SaplDocument();
		//for (Agent agent : agentsProvidingThisService) {
		//	document.addStatement(agent.getAgentAsResource(), InformingServiceProviderListener.provides, service.getName());
		//}
		//String sapl = document.generateSapl();
		String content = null;
		if (agentsProvidingThisService.size() > 0) {
			content = agentsProvidingThisService.iterator().next().getAgentAsResource().toString();
		} else {
			content = "";
		}
		message.setContent(content);
		message.setConversationId(this.conversationID);
		message.setOntology("<http://www.ubiware.jyu.fi/directoryFacilitator#service>");
		this.myAgent.send(message);

	}
}