package ubiware.infrastructure.ubiwareDF;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.udf;

public class RegisterWorkerBehavior extends ReusableAtomicBehavior {
	private static final long serialVersionUID = 1L;

	private Agent workerAgent;
	private Agent PUA;

	@Override
	protected void doAction() {
		ServiceRepository.getServiceRepository().registerWorkerAgent(this.workerAgent, this.PUA);
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		//udf:workerName sapl:is ?serviceName .
		//udf:PUAName sapl:is ?agentName .
		this.workerAgent = new Agent(parameters.getObligatedResourceParameter(udf.workerName));
		this.PUA = new Agent(parameters.getObligatedResourceParameter(udf.PUAName));
	}

}
