package ubiware.infrastructure.ubiwareDF;

import java.util.Set;

import ubiware.util.saplbuilder.Resource;

public class Service {

	private Set<Handler> handlers;
	private Resource serviceResource;

	public Service(Resource name, Set<Handler> handlers) {
		this.serviceResource = name;
		this.handlers = handlers;
	}

	/**
	 * @return the handlers
	 */
	public Set<Handler> getHandlers() {
		return this.handlers;
	}

	public Resource getName() {
		return this.serviceResource;
	}

	/**
	 * @return the serviceResource
	 */
	public String getNameAsString() {
		return this.serviceResource.toString();
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((this.serviceResource == null) ? 0 : this.serviceResource.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Service)) {
			return false;
		}
		Service other = (Service) obj;
		if (this.serviceResource == null) {
			if (other.serviceResource != null) {
				return false;
			}
		} else if (!this.serviceResource.equals(other.serviceResource)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return this.getNameAsString();
	}

}
