package ubiware.infrastructure.ubiwareDF;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.udf;
import ubiware.util.saplbuilder.Resource;

public class ServiceUnsubscriptionBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;
	private Resource serviceName;
	private Agent agent;

	@Override
	protected void doAction() {
		//ServiceProviderListener listener = new InformingServiceProviderListener(this.agent.getName(), this.myAgent);
		ServiceRepository.getServiceRepository().unSubscribeForService(this.serviceName, this.agent);
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.agent = new Agent(parameters.getObligatedResourceParameter(udf.agentName));
		this.serviceName = parameters.getObligatedResourceParameter(udf.serviceName);
	}
}
