package ubiware.infrastructure.ubiwareDF;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.com;
import ubiware.ontology.udf;
import ubiware.util.saplbuilder.Resource;

public class SubscribeForWorkersForServiceBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;
	private Agent PUA;
	private Resource serviceName;
	private Agent listenerAgent;
	private Resource conversationID;

	@Override
	protected void doAction() {
		ServiceProviderListener listener = new InformingServiceProviderListener(this.listenerAgent, this.myAgent, this.conversationID);
		ServiceRepository.getServiceRepository().subscribeForServiceByWorker(listener, this.serviceName, this.PUA, this.listenerAgent);

	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.PUA = new Agent(parameters.getObligatedResourceParameter(udf.PUAName));
		this.serviceName = parameters.getObligatedResourceParameter(udf.serviceName);
		this.listenerAgent = new Agent(parameters.getObligatedResourceParameter(udf.agentName));
		this.conversationID = parameters.getObligatedResourceParameter(com.convID);
	}
}
