package ubiware.infrastructure.ubiwareDF;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.udf;

public class UnRegisterHandlerBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;
	private Agent agent;
	private Handler handler;

	@Override
	protected void doAction() {
		ServiceRepository.getServiceRepository().unRegisterHandler(this.agent, this.handler);
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.agent = new Agent(parameters.getObligatedResourceParameter(udf.agentName));
		this.handler = new Handler(parameters.getObligatedResourceParameter(udf.handler));
	}
}
