package ubiware.infrastructure.web;

import ubiware.core.UbiwareAgent;
import ubiware.ontology.infra;
import ubiware.ontology.udf;
import ubiware.util.saplbuilder.ActionArgumentContainer;
import ubiware.util.saplbuilder.InvalidResourceException;
import ubiware.util.saplbuilder.Resource;

public class AgentWrapperProvider {
	private final UbiwareAgent bridgingAgent;

	public AgentWrapperProvider(UbiwareAgent bridgingAgent) {
		super();
		this.bridgingAgent = bridgingAgent;
	}

	public AgentWrapper getAgentWrapper(Resource agentName) {
		return new AgentWrapper(this.bridgingAgent, agentName);
	}

	public AgentWrapper getWorkerAgent(Resource PUA, Resource service) throws NoSuchWorkerException {
		AgentWrapper UDF = this.getAgentWrapper(infra.UbiwareDFAgent);
		ActionArgumentContainer parameters = new ActionArgumentContainer();
		parameters.addArgument(udf.PUAName, PUA);
		parameters.addArgument(udf.serviceName, service);
		String workerAgentName = UDF.syncAction(udf.SenderGetsWorkersForService, parameters);
		if ("".equals(workerAgentName)) {
			throw new NoSuchWorkerException();
		}
		Resource workerAgentResource;
		try {
			workerAgentResource = new Resource(workerAgentName);
		} catch (InvalidResourceException e) {
			throw new Error("All worker agent names must be valid resources", e);
		}
		return this.getAgentWrapper(workerAgentResource);
	}

}
