package ubiware.infrastructure.web;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AuthenticationFilter implements Filter {

	//	private FilterConfig filterConfig = null;
	private Set<String> exceptions = new HashSet<String>();

	@Override
	public void destroy() {
		this.exceptions.clear();
		this.exceptions = null;
	}

	@Override
	public void doFilter(ServletRequest req, ServletResponse resp, FilterChain fc) throws IOException, ServletException {

		String servletPath = ((HttpServletRequest) req).getServletPath();
		if (this.exceptions.contains(servletPath)) {
			fc.doFilter(req, resp);
			return;
		}

		PlatformInterface pi = (PlatformInterface) req.getAttribute(PlatformInterface.PLATFORM_INTERFACE_KEY);
		if (pi.isLoggedIn()) {
			fc.doFilter(req, resp);
		} else {
			//TODO consider changing to forward
			((HttpServletResponse) resp).sendRedirect("/");
			/*
			RequestDispatcher reqDispatcher = req.getRequestDispatcher("/");
			reqDispatcher.forward(req, resp);
			*/
		}

	}

	@Override
	public void init(FilterConfig filterConfiguration) throws ServletException {
		if (filterConfiguration != null) {
			String exceptionsParameterValue = filterConfiguration.getInitParameter("exceptions");
			if (exceptionsParameterValue != null) {
				String[] list = exceptionsParameterValue.split("\\.");
				for (String exception : list) {
					this.exceptions.add(exception);
				}
			}
		}
	}
}
