package ubiware.infrastructure.web;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

class DoLoginServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	//private WebServer jetty;

	private final TicketService ticketService;

	public DoLoginServlet(TicketService ticketService) {
		this.ticketService = ticketService;
	}

	@Override
	protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1) throws ServletException, IOException {
		this.doPost(arg0, arg1);
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		String username = req.getParameter("username");
		String password = req.getParameter("password");
		//authenticate
		try {
			Ticket ticket = this.ticketService.doLogin(username, password);
			resp.addCookie(new Cookie(TicketService.TICKET_KEY, ticket.asStringValue()));
			resp.setContentType("text/plain");
			resp.setStatus(HttpServletResponse.SC_OK);
			resp.getWriter().write(ticket.asStringValue());
			resp.flushBuffer();

		} catch (AuthenticationFailedException e) {
			resp.sendError(HttpServletResponse.SC_UNAUTHORIZED, "Authentication failed.");
			resp.flushBuffer();
		}
	}
}
