package ubiware.infrastructure.web;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

class DoLogoutServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;
	//private WebServer jetty;
	private final TicketService ticketService;

	public DoLogoutServlet(TicketService ticketService) {
		this.ticketService = ticketService;
	}

	@Override
	protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1) throws ServletException, IOException {
		this.doPost(arg0, arg1);
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			Ticket ticket = Util.getUbiwareTicket(req);
			this.ticketService.doLogOut(ticket);
		} catch (NoTicketException e) {
			//OK, in this case
		}
		resp.setStatus(HttpServletResponse.SC_OK);
	}

}
