package ubiware.infrastructure.web;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.param;
import ubiware.ontology.wia;
import ubiware.util.saplbuilder.Resource;
import ubiware.util.saplbuilder.SaplDocument;

public class StartWebServerBehavior extends ReusableAtomicBehavior {

	private int port;

	public static final int DEFAULT_PORT = 9333;

	@Override
	protected void doAction() {
		try {
			WebServer server = new WebServer(this.port, this.myAgent);
			Resource sID = this.addOnBlackboard(server);
			SaplDocument doc = new SaplDocument(1);
			doc.addStatement(wia.server, wia.hasBlackboardID, sID);
//			String belief = "<http://www.ubiware.jyu.fi/infrastructure/webInterfaceAgent#server> <http://www.ubiware.jyu.fi/infrastructure/webInterfaceAgent#hasBlackboardID> \""
//					+ sID + "\"";
			this.addBeliefsN3(doc);
		} catch (Exception e) {
			e.printStackTrace();
			this.setFailed();
			return;
		}
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.port = parameters.getOptionalNumericParameter(param.port, StartWebServerBehavior.DEFAULT_PORT);
	}

}
