package ubiware.infrastructure.web;

import ubiware.util.URITools;
import ubiware.util.UniqueInstanceGenerator;

public class Ticket {
	private static final UniqueInstanceGenerator IDGenerator = new UniqueInstanceGenerator("ticket" + Math.random(), URITools
			.createUncheckedURI("http://www.ubiware.jyu.fi/WebInterface/"));
	private final String hash;

	public Ticket() {
		String id = Ticket.IDGenerator.getNewID();
		this.hash = Util.encrypt(id);
		// "ticket_" + System.currentTimeMillis();
	}

	public Ticket(String value) {
		//TODO check validity of value
		this.hash = value;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Ticket) {
			return this.hash.equals(((Ticket) obj).hash);
		}
		return false;
	}

	public String asStringValue() {
		return this.hash;
	}

	@Override
	public String toString() {
		return "Ticket with ID " + this.asStringValue();
	}

	@Override
	public int hashCode() {
		return this.hash.hashCode();
	}
}
