package ubiware.infrastructure.web;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;

class Util {
	public static Ticket getUbiwareTicket(HttpServletRequest request) throws NoTicketException {
		Cookie[] temp = request.getCookies();
		String ticket = null;
		if (temp != null) {
			for (Cookie t : temp) {
				if (t.getName().equals(TicketService.TICKET_KEY)) {
					ticket = t.getValue();
				}
			}
		}
		//the other way is by expicitly putting the ticket as a get or post paremeter
		if(ticket == null){
			ticket = request.getParameter(TicketService.TICKET_KEY);
		}
		if (ticket == null) {
			throw new NoTicketException();
		}
		return new Ticket(ticket);
	}

	public static String encrypt(String original) {
		MessageDigest digest;
		try {
			digest = MessageDigest.getInstance("SHA-1");
		} catch (NoSuchAlgorithmException e) {
			throw new Error("The SHA-1 algorith is not found, cannot continue without.", e);
		}
		digest.reset();
		byte[] theDigest = digest.digest(original.getBytes());
		return Util.byteArrayToSafeString(theDigest);
	}

	private static String byteArrayToSafeString(byte[] b) {
		StringBuilder sb = new StringBuilder(b.length * 2);
		for (int i = 0; i < b.length; i++) {
			int v = b[i] & 0xff;
			sb.append(Integer.toHexString(v));
		}
		return sb.toString();
	}

}
