package ubiware.ontology;

import java.net.URI;

import ubiware.core.SaplN3Constants;
import ubiware.util.URITools;
import ubiware.util.saplbuilder.Resource;

public final class sapl {
	private sapl() {
		// utility class
	}

	public static final URI namespace = URITools.createUncheckedURI(SaplN3Constants.SAPL_NS);

	public static final Resource is = Resource.createUncheckedResource(SaplN3Constants.is);
	public static final Resource hasValue = Resource.createUncheckedResource(SaplN3Constants.hasValue);
	public static final Resource ID = Resource.createUncheckedResource(SaplN3Constants.ID);

	public static final Resource gt = Resource.createUncheckedResource(SaplN3Constants.gt);
	public static final Resource lt = Resource.createUncheckedResource(SaplN3Constants.lt);
	public static final Resource gte = Resource.createUncheckedResource(SaplN3Constants.gte);
	public static final Resource lte = Resource.createUncheckedResource(SaplN3Constants.lte);
	public static final Resource eq = Resource.createUncheckedResource(SaplN3Constants.eq);
	public static final Resource neq = Resource.createUncheckedResource(SaplN3Constants.neq);
	public static final Resource regex = Resource.createUncheckedResource(SaplN3Constants.regex);
	public static final Resource expression = Resource.createUncheckedResource(SaplN3Constants.expression);
	public static final Resource count = Resource.createUncheckedResource(SaplN3Constants.count);
	public static final Resource countGroupedBy = Resource.createUncheckedResource(SaplN3Constants.countGroupedBy);
	public static final Resource max = Resource.createUncheckedResource(SaplN3Constants.max);
	public static final Resource min = Resource.createUncheckedResource(SaplN3Constants.min);
	public static final Resource sum = Resource.createUncheckedResource(SaplN3Constants.sum);
	public static final Resource startsWith = Resource.createUncheckedResource(SaplN3Constants.startsWith);
	public static final Resource endsWith = Resource.createUncheckedResource(SaplN3Constants.endsWith);
	public static final Resource contains = Resource.createUncheckedResource(SaplN3Constants.contains);
	public static final Resource doesNotStartWith = Resource.createUncheckedResource(SaplN3Constants.doesNotStartWith);
	public static final Resource doesNotEndWith = Resource.createUncheckedResource(SaplN3Constants.doesNotEndWith);
	public static final Resource doesNotContain = Resource.createUncheckedResource(SaplN3Constants.doesNotContain);

	public static final Resource All = Resource.createUncheckedResource(SaplN3Constants.All);
	public static final Resource Some = Resource.createUncheckedResource(SaplN3Constants.Some);
	public static final Resource OrderBy = Resource.createUncheckedResource(SaplN3Constants.OrderBy);
	public static final Resource OrderByDescending = Resource.createUncheckedResource(SaplN3Constants.OrderByDescending);

	public static final Resource Limit = Resource.createUncheckedResource(SaplN3Constants.Limit);
	public static final Resource Offset = Resource.createUncheckedResource(SaplN3Constants.Offset);

	public static final Resource remove = Resource.createUncheckedResource(SaplN3Constants.remove);
	public static final Resource doNotBelieve = Resource.createUncheckedResource(SaplN3Constants.doNotBelieve);
	public static final Resource hasMember = Resource.createUncheckedResource(SaplN3Constants.hasMember);
	public static final Resource memberOf = Resource.createUncheckedResource(SaplN3Constants.memberOf);
	public static final Resource forSome = Resource.createUncheckedResource(SaplN3Constants.forSome);
	public static final Resource forAll = Resource.createUncheckedResource(SaplN3Constants.forAll);
	public static final Resource configuredAs = Resource.createUncheckedResource(SaplN3Constants.configuredAs);

	public static final Resource implies = Resource.createUncheckedResource(SaplN3Constants.implies); // =>
	public static final Resource impliesNow = Resource.createUncheckedResource(SaplN3Constants.impliesNow); // ->
	public static final Resource achievedBy = Resource.createUncheckedResource(SaplN3Constants.achievedBy); // >>
	public static final Resource infers = Resource.createUncheckedResource(SaplN3Constants.infers); // ==>

	public static final Resource I = Resource.createUncheckedResource(SaplN3Constants.I);

	public static final Resource missingModel = Resource.createUncheckedResource(SaplN3Constants.missingModel);

	public static final Resource Rule = Resource.createUncheckedResource(SaplN3Constants.Rule);
	public static final Resource MetaRule = Resource.createUncheckedResource(SaplN3Constants.MetaRule);

	public static final Resource FALSE = Resource.createUncheckedResource(SaplN3Constants.FALSE);
	public static final Resource TRUE = Resource.createUncheckedResource(SaplN3Constants.TRUE);
	public static final Resource ELSE = Resource.createUncheckedResource(SaplN3Constants.ELSE);

	public static final Resource want = Resource.createUncheckedResource(SaplN3Constants.want);

	public static final Resource achieving = Resource.createUncheckedResource(SaplN3Constants.achieving);

	public static final Resource eventFromGUI = Resource.createUncheckedResource(SaplN3Constants.eventFromGUI);

	public static final Resource doing = Resource.createUncheckedResource(SaplN3Constants.doing);
	public static final Resource erase = Resource.createUncheckedResource(SaplN3Constants.erase);
	public static final Resource or = Resource.createUncheckedResource(SaplN3Constants.or);
	public static final Resource Optional = Resource.createUncheckedResource(SaplN3Constants.Optional);
	public static final Resource add = Resource.createUncheckedResource(SaplN3Constants.add);
	public static final Resource Variable = Resource.createUncheckedResource(SaplN3Constants.Variable);
	public static final Resource eventFromSocket = Resource.createUncheckedResource(SaplN3Constants.eventFromSocket);
	public static final Resource Container = Resource.createUncheckedResource(SaplN3Constants.Container);
	public static final Resource Now = Resource.createUncheckedResource(SaplN3Constants.Now);
	public static final Resource Time = Resource.createUncheckedResource(SaplN3Constants.Time);
	public static final Resource Date = Resource.createUncheckedResource(SaplN3Constants.Date);
	public static final Resource DO = Resource.createUncheckedResource(SaplN3Constants.DO);//do
	public static final Resource NULL = Resource.createUncheckedResource(SaplN3Constants.NULL);//null
	public static final Resource Start = Resource.createUncheckedResource(SaplN3Constants.Start);
	public static final Resource End = Resource.createUncheckedResource(SaplN3Constants.End);
	public static final Resource Success = Resource.createUncheckedResource(SaplN3Constants.Success);
	public static final Resource Fail = Resource.createUncheckedResource(SaplN3Constants.Fail);
	public static final Resource Denied = Resource.createUncheckedResource(SaplN3Constants.Denied);
	public static final Resource missingRAB = Resource.createUncheckedResource(SaplN3Constants.missingRAB);
	public static final Resource haveName = Resource.createUncheckedResource(SaplN3Constants.haveName);
	public static final Resource executionID = Resource.createUncheckedResource(SaplN3Constants.executionID);
	public static final Resource requires = Resource.createUncheckedResource(SaplN3Constants.requires);
	public static final Resource existsWhile = Resource.createUncheckedResource(SaplN3Constants.existsWhile);

	public static final Resource hasBlackboardID = Resource.createUncheckedResource(SaplN3Constants.hasBlackboardID);
	public static final Resource requestsPath = Resource.createUncheckedResource(SaplN3Constants.requestsPath);

}
