package ubiware.ontology;

import java.net.URI;

import ubiware.util.URITools;
import ubiware.util.saplbuilder.Predicate;
import ubiware.util.saplbuilder.Resource;

public final class social {

	private social() {
		//utility class.
	}

	public static final URI users_namespace = URITools.createUncheckedURI("http://social.ubiware.jyu.fi/users#");
	public static final URI twitter_users_namespace = URITools.createUncheckedURI("http://social.ubiware.jyu.fi/twitter/users#");
	public static final URI twitter_status_namespace = URITools.createUncheckedURI("http://social.ubiware.jyu.fi/twitter/statuses#");
	public static final URI facebook_users_namespace = URITools.createUncheckedURI("http://social.ubiware.jyu.fi/facebook/users#");
	public static final URI facebook_statuses_namespace = URITools.createUncheckedURI("http://social.ubiware.jyu.fi/facebook/statuses#");
	public static final URI facebook_workExp_namespace = URITools.createUncheckedURI("http://social.ubiware.jyu.fi/facebook/workExperiences#");

	public static final URI namespace = URITools.createUncheckedURI("http://www.ubiware.jyu.fi/apps/socialNetworkApp#");

	public static final Predicate hasWorkExperience = Resource.createUncheckedResource(social.namespace, "hasWorkExperience");
	public static final Predicate hasSource = Resource.createUncheckedResource(social.namespace, "hasSource");
	public static final Predicate hasFirstName = Resource.createUncheckedResource(social.namespace, "hasFirstName");
	public static final Predicate hasLastName = Resource.createUncheckedResource(social.namespace, "hasLastName");
	public static final Predicate hasProfileURL = Resource.createUncheckedResource(social.namespace, "hasProfileURL");
	public static final Predicate hasBirthday = Resource.createUncheckedResource(social.namespace, "hasBirthday");
	public static final Predicate hasGender = Resource.createUncheckedResource(social.namespace, "hasGender");
	public static final Predicate hasConnection = Resource.createUncheckedResource(social.namespace, "hasConnection");
	public static final Predicate hasProfile = Resource.createUncheckedResource(social.namespace, "hasProfile");
	public static final Predicate hasDisplayName = Resource.createUncheckedResource(social.namespace, "hasDisplayName");
	public static final Predicate hasID = Resource.createUncheckedResource(social.namespace, "hasID");
	public static final Predicate hasProfilePictureURL = Resource.createUncheckedResource(social.namespace, "hasProfilePictureURL");
	public static final Predicate hasEmployer = Resource.createUncheckedResource(social.namespace, "hasEmployer");
	public static final Predicate hasEndDate = Resource.createUncheckedResource(social.namespace, "hasEndDate");
	public static final Predicate hasStartDate = Resource.createUncheckedResource(social.namespace, "hasStartDate");
	public static final Predicate hasPosition = Resource.createUncheckedResource(social.namespace, "hasPosition");

	public static final Resource HumanConnection_class = Resource.createUncheckedResource(social.namespace, "HumanConnection");
	public static final Resource LinkedInProfile_class = Resource.createUncheckedResource(social.namespace, "LinkedInProfile");
	public static final Resource PersonalUserNetwork_class = Resource.createUncheckedResource(social.namespace, "PersonalUserNetwork");
	public static final Resource SocialNetworkProfile_class = Resource.createUncheckedResource(social.namespace, "SocialNetworkProfile");
	public static final Resource TwitterProfile_class = Resource.createUncheckedResource(social.namespace, "TwitterProfile");
	public static final Resource FacebookProfile_class = Resource.createUncheckedResource(social.namespace, "FacebookProfile");
	public static final Resource WorkExperience_class = Resource.createUncheckedResource(social.namespace, "WorkExperience");

	//statuses
	public static final Predicate hasGeoLocation = Resource.createUncheckedResource(social.namespace, "hasGeoLocation");
	public static final Predicate hasText = Resource.createUncheckedResource(social.namespace, "hasText");
	public static final Predicate createdAt = Resource.createUncheckedResource(social.namespace, "createdAt");
	public static final Resource Status_class = Resource.createUncheckedResource(social.namespace, "Status");

	//geo location
	public static final Predicate hasLatitude = Resource.createUncheckedResource(social.namespace, "hasLatitude");
	public static final Predicate hasLongitude = Resource.createUncheckedResource(social.namespace, "hasLongitude");
	public static final Resource GeoLocation_class = Resource.createUncheckedResource(social.namespace, "GeoLocation");

	public static final Resource getAdaterInfo = Resource.createUncheckedResource(social.namespace, "getAdaterInfo");
	public static final Resource setAdaptorOAutht1Credentials = Resource.createUncheckedResource(social.namespace, "setAdaptorOAutht1Credentials");
	public static final Resource setAdaptorOAutht2Credentials = Resource.createUncheckedResource(social.namespace, "setAdaptorOAutht2Credentials");

	public static final Resource getAllAdapters = Resource.createUncheckedResource(social.namespace, "getAllAdapters");
	public static final Resource getPersonalUserNetwork = Resource.createUncheckedResource(social.namespace, "getPersonalUserNetwork");
	public static final Resource getAllProfilesFromAdapter = Resource.createUncheckedResource(social.namespace, "getAllProfilesFromAdapter");
	public static final Resource storePersonalUserNetwork = Resource.createUncheckedResource(social.namespace, "storePersonalUserNetwork");
	public static final Resource getRecentUpdatesFromConnection = Resource.createUncheckedResource(social.namespace, "getRecentUpdatesFromConnection");
	public static final Resource getProfileDetails = Resource.createUncheckedResource(social.namespace, "getProfileDetails");
	public static final Resource profileURI = Resource.createUncheckedResource(social.namespace, "profileURI");

}
