package ubiware.rdf2bean.social;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;
import java.util.Set;

import org.openrdf.query.MalformedQueryException;
import org.openrdf.query.QueryEvaluationException;
import org.openrdf.repository.RepositoryException;
import org.openrdf.rio.RDFParseException;

import ubiware.ontology.auth;
import ubiware.rdf2bean.core.RDFResource;
import ubiware.rdf2bean.core.Storage;
import ubiware.rdf2bean.social.helper.SocialHelper;

public class Adapter extends RDFResource {
	//soc:AdapterOAuth1

	//; oauth1:consumerKey ?consumerKey
	//; oauth1:consumerSecret consumerSecret
	//; oauth1:requestTokenURL ?tokenRequestURL
	//; oauth1:accessTokenURL ?accessTokenURL
	//; oauth1:authorizeURL ?authorizeURL

	//; oauth:version "1.0a"
	//; oauth:name ?name
	//; oauth:authenticated ?authenticated

	//; soc:handles ?adaptorHandles

	//private String version;
	//private String name;
	//private String authenticated;

	//private String handles;

	public static String handledResource = "http://www.ubiware.jyu.fi/apps/socialNetworkApp#Adapter";
	private String name;
	private boolean authenticated;

	//	public String getVersion() {
	//		String propertyName = "version";
	//		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_OAUTH, propertyName);
	//	}
	//
	//	public void setVersion(String value) {
	//		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH, "version", value);
	//	}

	public String getName() {
		return this.name;
	}

	//	public void setName(String value) {
	//		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH, "name", value);
	//	}

	public boolean getAuthenticated() {
		//String propertyName = "authenticated";
		//return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_OAUTH, propertyName);
		return this.authenticated;
	}

	//	public void setAuthenticated(String value) {
	//		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH, "authenticated", value);
	//	}

	//	public String getHandles() {
	//		String propertyName = "handles";
	//		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	//	}
	//
	//	public void setHandles(String value) {
	//		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "handles", value);
	//	}

	public Adapter(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
		this.name = SocialHelper.getObligatedSingleStringValue(this.properties, auth.displayName);//getSingleStringValue(this.properties, SocialHelper.NS_OAUTH, "hasDisplayName");
		this.authenticated = SocialHelper.getSingleBooleanValue(this.properties, auth.isAuthenticated);
	}

	//to test adapter
	public static void main(String[] args) throws SecurityException, NoSuchFieldException, RepositoryException, RDFParseException,
			MalformedQueryException, QueryEvaluationException, IllegalArgumentException, IOException, InstantiationException,
			IllegalAccessException, InvocationTargetException {
		String rdfCodeAsString = "@prefix soc: <http://www.ubiware.jyu.fi/apps/socialNetworkApp#> . @prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> . @prefix oauth: <http://oauth.net/> . @prefix oauth1: <http://tools.ietf.org/rfc/rfc5849#> . 	@prefix oauth2: <http://oauth.net/version2#> ."
				+ "<isbn:adapter1> rdf:type soc:Adapter "
				+ " ; oauth:version \"1.0a\""
				+ " ; oauth:name \"facebook adapter\""
				+ " ; oauth:authenticated \"false\"" + " ; soc:handles soc:FacebookProfile .\n";
		Storage s = SocialHelper.getDefaultStorage();
		s.register(Adapter.class, Adapter.handledResource);
		s.read(rdfCodeAsString);

		Adapter ad = s.getAllResourcesOfThisType(Adapter.class).iterator().next();
		System.out.println(ad.getUri());
		System.out.println(ad.getAuthenticated());
		//	System.out.println(ad.getHandles());
		System.out.println(ad.getName());
		//	System.out.println(ad.getVersion());
	}
}
