package ubiware.rdf2bean.social;

import java.util.Map;
import java.util.Set;

import ubiware.rdf2bean.core.Storage;
import ubiware.rdf2bean.social.helper.SocialHelper;

public class AdapterOAuth2 extends Adapter {
	public static String handledResource = "http://www.ubiware.jyu.fi/apps/socialNetworkApp#AdapterOAuth2";

	public AdapterOAuth2(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
	}

	public String getAccessTokenURL() {
		String propertyName = "accessTokenURL";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, propertyName);
	}

	public void setAccessTokenURL(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, "accessTokenURL", value);
	}

	public String getClientID() {
		String propertyName = "clientID";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, propertyName);
	}

	public String getClientSecret() {
		String propertyName = "clientSecret";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, propertyName);
	}

	public String getToken() {
		String propertyName = "token";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, propertyName);
	}

	public String getAuthURL() {
		String propertyName = "authorizeURL";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, propertyName);
	}

	public void setClientID(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, "clientID", value);
	}

	public void setClientSecret(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, "clientSecret", value);
	}

	public void setToken(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, "token", value);
	}

	public void setAuthURL(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_OAUTH2, "authorizeURL", value);
	}

}
