package ubiware.rdf2bean.social;

import java.util.Map;
import java.util.Set;

import ubiware.rdf2bean.core.RDFResource;
import ubiware.rdf2bean.core.Storage;
import ubiware.rdf2bean.social.helper.SocialHelper;

public class GeoLocation extends RDFResource {
	public static String handledResource = "http://www.ubiware.jyu.fi/apps/socialNetworkApp#GeoLocation";

	public GeoLocation(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
	}

	private static final long serialVersionUID = 1L;

	//private double hasLatitude;
	//private double hasLongitude;

	public double getHasLatitude() {
		String propertyName = "hasLatitude";
		String stringVal = SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
		return Double.parseDouble(stringVal);
	}

	public void setHasLatitude(double hasLatitude) {
		String value = String.valueOf(hasLatitude);
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasLatitude", value);
	}

	public double getHasLongitude() {
		String propertyName = "hasLongitude";
		String stringVal = SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
		return Double.parseDouble(stringVal);
	}

	public void setHasLongitude(double hasLongitude) {
		String value = String.valueOf(hasLongitude);
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasLongitude", value);
	}

	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return "(GeoLocation: lat=" + this.getHasLatitude() + ", lon=" + this.getHasLongitude() + ")";
	}

}
