package ubiware.rdf2bean.social;

import java.util.List;
import java.util.Map;
import java.util.Set;

import ubiware.rdf2bean.core.RDFResource;
import ubiware.rdf2bean.core.Storage;
import ubiware.rdf2bean.social.helper.SocialHelper;

public class HumanConnection extends RDFResource {
	public static String handledResource = "http://www.ubiware.jyu.fi/apps/socialNetworkApp#HumanConnection";

	public HumanConnection(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
	}

	private static final long serialVersionUID = 1L;

	//private List<SocialNetworkProfile> hasProfile;
	//private String hasDisplayName;

	public List<SocialNetworkProfile> getHasProfile() {
		String propertyName = "hasProfile";
		return SocialHelper.getMultipleNonStringValues(this.getStorage(), this.properties, propertyName, SocialNetworkProfile.class);
	}

	public void setHasProfile(List<SocialNetworkProfile> listProfiles) {
		String propertyName = "hasProfile";
		SocialHelper.setMultipleNonStringValues(this.getStorage(), this.properties, propertyName, listProfiles);
	}

	public String getHasDisplayName() {
		String propertyName = "hasDisplayName";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasDisplayName(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasDisplayName", value);
	}

	@Override
	public String toString() {
		return this.getUri();
	}

	/** Start - Convenience methods for Mashupper webapp **/

	public <T extends SocialNetworkProfile> T getProfileByType(Class<T> class1) {
		for (ubiware.rdf2bean.social.SocialNetworkProfile p : this.getHasProfile()) {
			try{
				T result = class1.cast(p);
				return result;
			}catch (Exception e) {
				//if the cast fails, just continue trying.
			}
		}
		return null;

	}

	/** End - Convenience methods for Mashupper webapp **/

}
