package ubiware.rdf2bean.social;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.Set;

import ubiware.rdf2bean.core.RDFResource;
import ubiware.rdf2bean.core.Storage;
import ubiware.rdf2bean.social.helper.SocialHelper;

public class Message extends RDFResource {
	public static String handledResource = "http://www.ubiware.jyu.fi/apps/socialNetworkApp#Message";
	private DateFormat df = new SimpleDateFormat(SocialHelper.DATE_FORMAT);

	public Message(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
	}

	public HumanConnection getHasReceiver() {
		String propertyName = "hasReceiver";
		return SocialHelper.getSingleNonStringValue(this.getStorage(), this.properties, propertyName, HumanConnection.class);
	}

	public void setHasReceiver(HumanConnection value) {
		String propertyName = "hasReceiver";
		SocialHelper.setSingleNonStringValue(this.getStorage(), this.properties, propertyName, value);
	}

	public HumanConnection getHasSender() {
		String propertyName = "hasSender";
		return SocialHelper.getSingleNonStringValue(this.getStorage(), this.properties, propertyName, HumanConnection.class);
	}

	public void setHasSender(HumanConnection value) {
		String propertyName = "hasSender";
		SocialHelper.setSingleNonStringValue(this.getStorage(), this.properties, propertyName, value);
	}

	public String getHasType() {
		String propertyName = "hasType";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasType(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasType", value);
	}

	public String getHasSubject() {
		String propertyName = "hasSubject";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasSubject(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasSubject", value);
	}

	public String getHasText() {
		String propertyName = "hasText";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasText(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasText", value);
	}

	public GeoLocation getHasGeoLocation() {
		String propertyName = "hasGeoLocation";
		return SocialHelper.getSingleNonStringValue(this.getStorage(), this.properties, propertyName, GeoLocation.class);
	}

	public void setHasGeoLocation(GeoLocation hasGeoLocation) {
		String propertyName = "hasGeoLocation";
		SocialHelper.setSingleNonStringValue(this.getStorage(), this.properties, propertyName, hasGeoLocation);
	}

	public Date getCreatedAt() {
		String propertyName = "createdAt";
		String stringDate = SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
		Date dateDate;
		try {
			dateDate = this.df.parse(stringDate);
		} catch (ParseException e) {
			dateDate = null;
		}
		return dateDate;
	}

	public void setCreatedAt(Date value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "createdAt", this.df.format(value));
	}

}
