package ubiware.rdf2bean.social;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.openrdf.query.MalformedQueryException;
import org.openrdf.query.QueryEvaluationException;
import org.openrdf.repository.RepositoryException;
import org.openrdf.rio.RDFParseException;

import ubiware.rdf2bean.core.Storage;
import ubiware.rdf2bean.social.helper.SocialHelper;

public class PhoneBookProfile extends SocialNetworkProfile {
	public static String handledResource = "http://www.ubiware.jyu.fi/apps/socialNetworkApp#PhoneBookProfile";

	public PhoneBookProfile(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
	}

	private static final long serialVersionUID = 1L;

	//private String hasID;
	//private String hasFirstName;
	//private String hasLastName;
	//private String hasBirthday;
	//private String hasDisplayName;

	//	private String hasProfileURL;
	//	private String hasUpdatedTime;
	//	private String hasGender;
	//	private Collection<WorkExperience> hasWorkExperience;
	//	private String hasProfilePictureURL;

	/** Start - Convenience methods for Mashupper webapp **/

	@Override
	public String getProfileProviderImageURL() {
		return "VAADIN/themes/mashuppertheme/images/facebook-icon24.png";
	}

	/** End - Convenience methods for Mashupper webapp **/
	/*
	public static void main(String[] args) {
		Storage s = SocialHelper.getDefaultStorage();
		s.register(cl, resourceURI);
		String rdfCodeAsString = testForJoonas
		
	}
	*/

	public List<Message> getHasMessage() {
		String propertyName = "hasMessage";
		return SocialHelper.getMultipleNonStringValues(this.getStorage(), this.properties, propertyName, Message.class);
	}

	public void setHasMessage(List<Message> listMsgs) {
		String propertyName = "hasMessage";
		SocialHelper.setMultipleNonStringValues(this.getStorage(), this.properties, propertyName, listMsgs);
	}

	public String getHasPhoneNumber() {
		String propertyName = "hasPhoneNumber";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasPhoneNumber(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasPhoneNumber", value);
	}

	public static void main(String[] args) throws MalformedQueryException, QueryEvaluationException, IllegalArgumentException, IOException,
			InstantiationException, IllegalAccessException, InvocationTargetException, SecurityException, NoSuchFieldException,
			RepositoryException, RDFParseException {
		String rdfCodeAsString = "@prefix soc: <http://www.ubiware.jyu.fi/apps/socialNetworkApp#> . @prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> . @prefix oauth: <http://oauth.net/> . @prefix oauth1: <http://tools.ietf.org/rfc/rfc5849#> . 	@prefix oauth2: <http://oauth.net/version2#> ."
				+ "<isbn:phoneBookJohn> rdf:type soc:PhoneBookProfile "
				+ " ; soc:hasPhoneNumber \"+358556453423\""
				+ " ; soc:hasMessage soc:sms1, soc:email1 . \n\n";
		rdfCodeAsString += "soc:sms1 rdf:type soc:Message ; soc:hasType \"sms\"  ; soc:hasText \"Hi, can we meet at 2pm and go for lunch?\"  ; soc:hasReceiver <http://xx.com/hc1> ; soc:createdAt \"17-09-2010 12-00-00 GMT\"  ; soc:hasGeoLocation <loc1> . \n\n";
		rdfCodeAsString += "soc:email1 rdf:type soc:Message ; soc:hasType \"email\"  ; soc:hasSubject \"New course\"  ; soc:hasText \"Hello, what time do we have the first lecture of the course?\"  ; soc:hasDestination \"teacher@jyu.fi\" ; soc:createdAt \"17-09-2010 11-00-00 GMT\"  . \n\n";
		rdfCodeAsString += "<http://xx.com/hc1> rdf:type soc:HumanConnection . \n\n";
		rdfCodeAsString += "<loc1> rdf:type soc:GeoLocation ; soc:hasLatitude \"123\" ; soc:hasLongitude \"22\" . \n\n";

		Storage s = SocialHelper.getDefaultStorage();
		s.register(PhoneBookProfile.class, PhoneBookProfile.handledResource);
		s.register(Message.class, Message.handledResource);
		s.register(HumanConnection.class, HumanConnection.handledResource);
		s.register(GeoLocation.class, GeoLocation.handledResource);
		s.read(rdfCodeAsString);
		System.out.println(rdfCodeAsString);

		PhoneBookProfile ad = s.getAllResourcesOfThisType(PhoneBookProfile.class).iterator().next();
		System.out.println(ad.getUri());
		System.out.println(ad.getHasPhoneNumber());
		List<Message> xx = ad.getHasMessage();
		for (Message m : xx) {
			System.out.println();
			System.out.println(m.getUri());
			System.out.println(m.getHasText());
			System.out.println(m.getHasSender());
			System.out.println(m.getHasReceiver());
			System.out.println(m.getHasSubject());
			System.out.println(m.getHasType());
			System.out.println(m.getHasGeoLocation());
		}
	}

}
