package ubiware.rdf2bean.social;

import java.util.List;
import java.util.Map;
import java.util.Set;

import ubiware.rdf2bean.core.RDFResource;
import ubiware.rdf2bean.core.Storage;
import ubiware.rdf2bean.social.helper.SocialHelper;

public class SocialNetworkProfile extends RDFResource {

	public SocialNetworkProfile(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
	}

	public String getHasProfilePictureURL() {
		String propertyName = "hasProfilePictureURL";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasProfilePictureURL(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasProfilePictureURL", value);
	}

	public String getHasBirthday() {
		String propertyName = "hasBirthday";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasBirthday(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasBirthday", value);
	}

	public String getHasProfileURL() {
		String propertyName = "hasProfileURL";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasProfileURL(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasProfileURL", value);
	}

	public String getHasID() {
		String propertyName = "hasID";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasID(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasID", value);
	}

	public String getHasFirstName() {
		String propertyName = "hasFirstName";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasFirstName(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasFirstName", value);
	}

	public String getHasLastName() {
		String propertyName = "hasLastName";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasLastName(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasLastName", value);
	}

	public String getHasDisplayName() {
		String propertyName = "hasDisplayName";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public void setHasDisplayName(String value) {
		SocialHelper.setSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasDisplayName", value);
	}

	public List<Status> getHasStatus() {
		String propertyName = "hasStatus";
		return SocialHelper.getMultipleNonStringValues(this.getStorage(), this.properties, propertyName, Status.class);
	}

	public void setHasStatus(List<Status> listTweets) {
		String propertyName = "hasStatus";
		SocialHelper.setMultipleNonStringValues(this.getStorage(), this.properties, propertyName, listTweets);
	}

	public List<WorkExperience> getHasWorkExperience() {
		String propertyName = "hasWorkExperience";
		return SocialHelper.getMultipleNonStringValues(this.getStorage(), this.properties, propertyName, WorkExperience.class);
	}

	public void setHasWorkExperience(List<WorkExperience> listWorkExp) {
		String propertyName = "hasWorkExperience";
		SocialHelper.setMultipleNonStringValues(this.getStorage(), this.properties, propertyName, listWorkExp);
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder("[" + this.getUri() + ",\n");
		sb.append("(getHasDisplayName=" + this.getHasDisplayName() + "),\n");
		sb.append("(getHasFirstName=" + this.getHasFirstName() + "),\n");
		sb.append("(getHasID=" + this.getHasID() + "),\n");
		sb.append("(getHasLastName=" + this.getHasLastName() + "),\n");
		sb.append("(getHasProfileURL=" + this.getHasProfileURL() + "),\n");
		sb.append("(getHasLastName=" + this.getHasLastName() + "),\n");
		sb.append("(getHasBirthday=" + this.getHasBirthday() + "),\n");
		sb.append("]\n");
		return sb.toString();
	}

	/** Start - Convenience methods for Mashupper webapp **/

	public final String getProfileImageURL() {
		//return "";
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, "hasProfilePictureURL");
	}

	public String getSingleStringPropertyValue(String propertyName) {
		return SocialHelper.getSingleStringValue(this.properties, SocialHelper.NS_SOCIAL, propertyName);
	}

	public String getProfileProviderImageURL() {
		return "";
	}

	/** End - Convenience methods for Mashupper webapp **/
}
