package ubiware.shared;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.core.UbiwareAgent;
import ubiware.ontology.param;

/**
 * RAB which implements the same functionality as the embedded :Print action.
 * 
 * @author Michael Cochez for Ubiware project
 * @since 22 Jul 2010
 */
public class PrintBehavior extends ReusableAtomicBehavior {
	private static final long serialVersionUID = 1L;
	private String toPrint;
	private boolean isError;

	@Override
	protected void doAction() {
		//TODO is this behavior acceptable?
		if (this.toPrint.startsWith(UbiwareAgent.CONTEXT_PREFIX)) {
			this.print(this.produceN3(this.toPrint));
		} else {
			this.print(this.toPrint);
		}
	}

	@Override
	public void print(Object text) {
		// TODO Auto-generated method stub
		if (this.isError) {
			StringBuilder builder = new StringBuilder();
			builder.append(this.myAgent.getLocalName());
			builder.append("reports error :");
			builder.append(text);
			System.err.println(builder);
		}
		super.print(text);
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.toPrint = parameters.getObligatedStringParameter(param.print);
		this.isError = parameters.getOptionalBooleanParameter(param.error, false);
	}
}
