package ubiware.shared;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ProduceN3Options;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.core.UbiwareAgent;
import ubiware.ontology.param;

/**
 * The RAB representing the embedded action :PrintBeliefs
 * 
 * @author Michael Cochez for Ubiware project
 * @since 30 Jul 2010
 */
public class PrintBeliefsBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;

	private String context;
	private ProduceN3Options options;

	@Override
	protected void doAction() {
		this.print(this.produceN3(this.context, this.options));
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.context = parameters.getOptionalStringParameter(param.print, UbiwareAgent.GENERAL_CONTEXT);
		boolean indents = parameters.getOptionalBooleanParameter(param.indents, false);
		this.options = new ProduceN3Options(indents, true);
	}

}
