package ubiware.shared;

import jade.core.AID;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

import java.util.Collection;
import java.util.Iterator;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.param;
import ubiware.util.saplbuilder.Resource;
@Deprecated
public class SecurityCheckBehavior extends ReusableAtomicBehavior {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Resource from;
	private Collection<String> allowedFrom;

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.from = parameters.getObligatedResourceParameter(param.agent);
		this.allowedFrom = parameters.getParameterValues(param.authorized);
	}

	@Override
	public void doAction() {

		boolean OK = false;

		DFAgentDescription template = new DFAgentDescription();
		template.setName(new AID(this.from.toString(), AID.ISLOCALNAME));
		String auth_role = "";
		try {
			DFAgentDescription[] result = DFService.search(this.myAgent, template);
			if (result.length == 1) {
				DFAgentDescription considerredDescription = result[0];
				Iterator<ServiceDescription> it = SecurityCheckBehavior.getAllServices(considerredDescription);
				while (it.hasNext()) {
					String hasRole = (it.next()).getName();
					if (this.allowedFrom.contains(hasRole)) {
						OK = true;
						auth_role = hasRole;
					}
				}
			}
		} catch (FIPAException fe) {
			fe.printStackTrace();
			this.setFailed();
			return;
		}

		if (OK) {
			this.print(this.from + " is authorized as " + auth_role);
		} else {
			this.setFailed();
			this.print(this.from + " has not been authorized!");
		}
	}

	@SuppressWarnings("unchecked")
	private static Iterator<ServiceDescription> getAllServices(DFAgentDescription considerredDescription) {
		return considerredDescription.getAllServices();
	}

}
