package ubiware.shared;

import java.io.File;
import java.util.HashMap;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.param;
import ubiware.util.StreamingUtils;

public class TextReaderBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;
	private File file;
	private String saveTo;

	@Override
	protected void initializeRAB(BehaviorStartParameters behaviorStartParameters) throws IllegalParameterConfigurationException {
		this.file = behaviorStartParameters.getObligatedFileParameter(param.input);
		this.saveTo = behaviorStartParameters.getObligatedContainerID(param.saveTo);
	}

	@Override
	protected void doAction() throws Exception {
		String text = StreamingUtils.getInputFromFile(this.file);
		HashMap<String, String> vars = new HashMap<String, String>();
		vars.put("result", text);
		this.addBeliefs(this.saveTo, vars);
	}
}
