package ubiware.shared.agentServer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.jetty.continuation.Continuation;

/**
 * The serverEvent from {@link AgentServerBehavior} This event encapsulates a {@link HttpServletRequest}, {@link HttpServletResponse} and a
 * {@link Continuation} connected to a http event. This class is immutable 18.3.2010
 * 
 * @author Michael Cochez for UBIWARE project
 */
public class AgentServerBehaviorServerEvent {
	private final HttpServletRequest request;
	private final HttpServletResponse response;
	private Continuation continuation;

	public AgentServerBehaviorServerEvent(HttpServletRequest request, HttpServletResponse response, Continuation continuation) {
		super();
		this.response = response;
		this.request = request;
		this.continuation = continuation;
	}

	public HttpServletResponse getResponse() {
		return this.response;
	}

	public HttpServletRequest getRequest() {
		return this.request;
	}

	public Continuation getContinuation() {
		return this.continuation;
	}

}
