package ubiware.shared.gui.buttonGUI;

import java.awt.EventQueue;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.core.IllegalParameterConfigurationException.State;
import ubiware.ontology.param;
import ubiware.util.saplbuilder.Resource;

public class DisposeGUIBehavior extends ReusableAtomicBehavior {

	private ButtonGUI gui;
	private Resource GUIID;

	@Override
	protected void doAction() {
		EventQueue.invokeLater(new Runnable() {
			@Override
			public void run() {
				DisposeGUIBehavior.this.gui.setVisible(false);
			}
		});
		try {
			GUIRepository.dispose(this.myAgent.getAID(), this.GUIID, this.gui);
		} catch (NoSuchGUIException e) {
			//this should never happen, the gui was retrieved from the Repository
			throw new Error("This should never happen, the gui was right before retrieved from the repository.", e);
		}
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.GUIID = parameters.getOptionalResourceParameter(param.ID);
		try {
			this.gui = GUIRepository.getGUI(this.myAgent.getAID(), this.GUIID);
		} catch (NoSuchGUIException e) {
			throw new IllegalParameterConfigurationException(param.ID, this.GUIID.toString(), State.notInRange, e);
		}
	}

}
