package ubiware.shared.gui.buttonGUI;

import java.awt.EventQueue;

import javax.swing.JButton;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.core.IllegalParameterConfigurationException.State;
import ubiware.ontology.param;
import ubiware.util.saplbuilder.Resource;

public class EnableButtonBehavior extends ReusableAtomicBehavior {

	private static final long serialVersionUID = 1L;
	private JButton button;

	@Override
	protected void doAction() {
		EventQueue.invokeLater(new Runnable() {
			@Override
			public void run() {
				EnableButtonBehavior.this.button.setEnabled(true);
			}
		});
	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		Resource GUIID = parameters.getOptionalResourceParameter(param.ID);
		ButtonGUI GUI;
		try {
			GUI = GUIRepository.getGUI(this.myAgent.getAID(), GUIID);
		} catch (NoSuchGUIException e) {
			throw new IllegalParameterConfigurationException(param.ID, GUIID.toString(), State.notInRange, e);
		}
		String targetString = parameters.getObligatedNonEmptyStringParameter(param.target);
		this.button = GUI.textToButton.get(targetString);
		if (this.button == null) {
			throw new IllegalParameterConfigurationException(param.target, targetString, State.notInRange);
		}
	}

}
