package ubiware.shared.gui.buttonGUI;

import jade.core.AID;

import java.awt.EventQueue;
import java.lang.reflect.InvocationTargetException;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import ubiware.core.BehaviorStartParameters;
import ubiware.core.IllegalParameterConfigurationException;
import ubiware.core.IllegalParameterConfigurationException.State;
import ubiware.core.ReusableAtomicBehavior;
import ubiware.ontology.param;
import ubiware.util.saplbuilder.Resource;

public class NewGUIBehavior extends ReusableAtomicBehavior {

	private String title;
	private int state;
	private Resource GUIID;
	private Collection<String> buttons;
	private String text;
	private boolean allowClose;

	@Override
	protected void doAction() {

		try {
			EventQueue.invokeAndWait(new Runnable() {

				@Override
				public void run() {
					ButtonGUI theGUI = new ButtonGUI(NewGUIBehavior.this.text, NewGUIBehavior.this.buttons, NewGUIBehavior.this.myAgent,
							NewGUIBehavior.this.GUIID, NewGUIBehavior.this.allowClose);
					theGUI.setTitle(NewGUIBehavior.this.title);
					theGUI.setState(NewGUIBehavior.this.state);

					theGUI.setVisible(true);
					//register the GUI
					AID myAgentID = NewGUIBehavior.this.myAgent.getAID();
					//register the GUI to make it possible for other related behaviors to access it.
					GUIRepository.registerGUI(myAgentID, NewGUIBehavior.this.GUIID, theGUI);
				}
			});
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	@Override
	protected void initializeRAB(BehaviorStartParameters parameters) throws IllegalParameterConfigurationException {
		this.buttons = parameters.getParameterValues(param.button);
		if (this.buttons == null) {
			throw new IllegalParameterConfigurationException(param.button, null, State.missing);
		}
		//check whether there are two buttons with the same text, this is not allowed!
		Set<String> entries = new HashSet<String>();
		for (String buttonName : this.buttons) {
			if (entries.contains(buttonName)) {
				throw new IllegalParameterConfigurationException(param.button, buttonName, State.conflicting);
			}
			entries.add(buttonName);
		}
		this.GUIID = parameters.getOptionalResourceParameter(param.ID);
		if (this.GUIID == null) {
			this.GUIID = GUIRepository.GUIIDGenerator.getNewResource();
		}
		this.title = parameters.getOptionalStringParameter(param.title, this.myAgent.getName());
		this.text = parameters.getOptionalStringParameter(param.text);
		this.allowClose = parameters.getOptionalBooleanParameter(param.closable, true);
	}

}
