package ubiware.shared.persistency;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

public class CreatePersistentStore {

	static void ensureStorageExistence() throws SQLException {
		if (DatabaseProperties.databaseFolder == null) {
			System.err.println("ubiware.shared.persistency.databaseFolder could not be read from properties, assuming that the db does not need any folders.");
		} else {
			File f = new File(DatabaseProperties.databaseFolder);
			f.mkdirs();
		}

		org.sqlite.JDBC.class.getName();
		Connection conn = DriverManager
				.getConnection(DatabaseProperties.JDBCConnectionURL);
		ensureStorageExistence(conn);
		conn.close();
	}

	private static void ensureStorageExistence(Connection conn) throws SQLException {
		Statement stat = conn.createStatement();
		stat.executeUpdate("create table if not exists persistentstore (id PRIMARY KEY NOT NULL UNIQUE, sapl);");
		stat.close();
	}
	
	public static void main(String[] args) throws SQLException {
		CreatePersistentStore.ensureStorageExistence();
	}
}
