package ubiware.util;

import ubiware.core.UbiwareAgent;

/**
 * A generator for contextID's
 * 
 * @author Michael Cochez for the Ubiware project
 */
public class ContextIDGenerator extends Counter {
	/**
	 * The maximum number of digits a string representation from a long in base 10 can have 9223372036854775807 is the longest long.
	 * 
	 */
	private final static int MAX_LONG_STRING_LENGTH = 19;

	/**
	 * The maximum length a context ID can ever have, used as bounds for the Stringbuilder.
	 */
	private final static int MAX_ID_LENGTH = ContextIDGenerator.MAX_LONG_STRING_LENGTH + UbiwareAgent.CONTEXT_PREFIX.length();

	/**
	 * get the next unique contextID
	 * 
	 * @return String representation of the ID
	 */
	public String getNewContextID() {
		StringBuilder builder = new StringBuilder(ContextIDGenerator.MAX_ID_LENGTH);
		builder.append(UbiwareAgent.CONTEXT_PREFIX);
		builder.append(super.getNextNumber());
		return builder.toString();
	}
}
