package ubiware.util;

import java.net.URI;

/**
 * This class implements an ID generator, every time getNewID is called, a new uninque ID is generated. The id's are in the
 * "http://www.ubiware.jyu.fi/id#" namespace
 * 
 * @since 18.3.2010
 * @author Michael Cochez for UBIWARE project
 */
public class IDGenerator extends UniqueInstanceGenerator {

	/**
	 * The URI used to prefix all ID's.
	 */
	public static final URI ID_NS_URI = URITools.createUncheckedURI("http://www.ubiware.jyu.fi/id/");

	/**
	 * Create an IDGenerator which uses the given prefix.
	 * 
	 * @param prefixForID
	 *            the prefix for the IDs
	 */
	public IDGenerator(final String prefixForID) {
		super(prefixForID, IDGenerator.ID_NS_URI);
	}

	//	public static void main(String[] args) {
	//		ExecutorService service = Executors.newFixedThreadPool(50);
	//		final IDGenerator idgen = new IDGenerator("test");
	//		final Set<String> idset = Collections.synchronizedSet(new HashSet<String>());
	//		for (final int i : new Range(50)) {
	//			service.execute(new Runnable() {
	//
	//				@Override
	//				public void run() {
	//					for (int j : new Range(1000)) {
	//						String id = idgen.getNewID();
	//						if (!idset.contains(id)) {
	//							System.out.println(i + id);
	//							idset.add(id);
	//						} else {
	//							throw new Error("implementation failure.");
	//						}
	//					}
	//				}
	//			});
	//		}
	//		try {
	//			service.shutdown();
	//			service.awaitTermination(1000, TimeUnit.SECONDS);
	//		} catch (InterruptedException e) {
	//			// TODO Auto-generated catch block
	//			e.printStackTrace();
	//		}
	//List<String> list = new java.util.ArrayList<String>(idset);
	//Collections.sort(list);
	//System.out.println(list);
	//	}
}
