package ubiware.util;

import java.net.URI;

import ubiware.util.URITools;

/**
 * This class provides strings which are built-in into the SaplN3 language. Other classes should refer to this class when using constants.
 * Further documentation about these constants can be found in the Sapl guide. 27.5.2010
 * 
 * @author Michael Cochez for UBIWARE project
 */
public final class SaplN3Constants {
	public static final String SAPL_NS = "http://www.ubiware.jyu.fi/sapl#";
	public static final String RAB_NS = "http://www.ubiware.jyu.fi/rab#";
	public static final String PARAM_NS = "http://www.ubiware.jyu.fi/rab_parameters#";

	public static final String is = "<" + SaplN3Constants.SAPL_NS + "is>";
	public static final String hasValue = "<" + SaplN3Constants.SAPL_NS + "hasValue>";
	public static final String ID = "<" + SaplN3Constants.SAPL_NS + "ID>";

	public static final String gt = "<" + SaplN3Constants.SAPL_NS + "gt>";
	public static final String lt = "<" + SaplN3Constants.SAPL_NS + "lt>";
	public static final String gte = "<" + SaplN3Constants.SAPL_NS + "gte>";
	public static final String lte = "<" + SaplN3Constants.SAPL_NS + "lte>";
	public static final String eq = "<" + SaplN3Constants.SAPL_NS + "eq>";
	public static final String neq = "<" + SaplN3Constants.SAPL_NS + "neq>";
	public static final String regex = "<" + SaplN3Constants.SAPL_NS + "regex>";
	public static final String expression = "<" + SaplN3Constants.SAPL_NS + "expression>";
	public static final String count = "<" + SaplN3Constants.SAPL_NS + "count>";
	public static final String countGroupedBy = "<" + SaplN3Constants.SAPL_NS + "countGroupedBy>";
	public static final String max = "<" + SaplN3Constants.SAPL_NS + "max>";
	public static final String min = "<" + SaplN3Constants.SAPL_NS + "min>";
	public static final String sum = "<" + SaplN3Constants.SAPL_NS + "sum>";
	public static final String startsWith = "<" + SaplN3Constants.SAPL_NS + "startsWith>";
	public static final String endsWith = "<" + SaplN3Constants.SAPL_NS + "endsWith>";
	public static final String contains = "<" + SaplN3Constants.SAPL_NS + "contains>";
	public static final String doesNotStartWith = "<" + SaplN3Constants.SAPL_NS + "doesNotStartWith>";
	public static final String doesNotEndWith = "<" + SaplN3Constants.SAPL_NS + "doesNotEndWith>";
	public static final String doesNotContain = "<" + SaplN3Constants.SAPL_NS + "doesNotContain>";

	public static final String All = "<" + SaplN3Constants.SAPL_NS + "All>";
	public static final String Some = "<" + SaplN3Constants.SAPL_NS + "Some>";
	public static final String OrderBy = "<" + SaplN3Constants.SAPL_NS + "OrderBy>";
	public static final String OrderByDescending = "<" + SaplN3Constants.SAPL_NS + "OrderByDescending>";

	public static final String Limit = "<" + SaplN3Constants.SAPL_NS + "Limit>";
	public static final String Offset = "<" + SaplN3Constants.SAPL_NS + "Offset>";

	public static final String remove = "<" + SaplN3Constants.SAPL_NS + "remove>";
	public static final String doNotBelieve = "<" + SaplN3Constants.SAPL_NS + "doNotBelieve>";
	public static final String hasMember = "<" + SaplN3Constants.SAPL_NS + "hasMember>";
	public static final String memberOf = "<" + SaplN3Constants.SAPL_NS + "memberOf>";
	public static final String forSome = "<" + SaplN3Constants.SAPL_NS + "forSome>";
	public static final String forAll = "<" + SaplN3Constants.SAPL_NS + "forAll>";
	public static final String configuredAs = "<" + SaplN3Constants.SAPL_NS + "configuredAs>";

	public static final String implies = "<" + SaplN3Constants.SAPL_NS + "implies>"; // =>
	public static final String impliesNow = "<" + SaplN3Constants.SAPL_NS + "impliesNow>"; // ->
	public static final String achievedBy = "<" + SaplN3Constants.SAPL_NS + "achievedBy>"; // >>
	public static final String infers = "<" + SaplN3Constants.SAPL_NS + "infers>"; // ==>

	public static final String I = "<" + SaplN3Constants.SAPL_NS + "I>";

	public static final String missingModel = "<" + SaplN3Constants.SAPL_NS + "missingModel>";

	public static final String Rule = "<" + SaplN3Constants.SAPL_NS + "Rule>";
	public static final String MetaRule = "<" + SaplN3Constants.SAPL_NS + "MetaRule>";

	public static final String FALSE = "<" + SaplN3Constants.SAPL_NS + "false>";
	public static final String TRUE = "<" + SaplN3Constants.SAPL_NS + "true>";
	public static final String ELSE = "<" + SaplN3Constants.SAPL_NS + "else>";

	public static final String want = "<" + SaplN3Constants.SAPL_NS + "want>";

	public static final String achieving = "<" + SaplN3Constants.SAPL_NS + "achieving>";

	public static final String eventFromGUI = "<" + SaplN3Constants.SAPL_NS + "eventFromGUI>";

	public static final String doing = "<" + SaplN3Constants.SAPL_NS + "doing>";
	public static final String erase = "<" + SaplN3Constants.SAPL_NS + "erase>";
	public static final String or = "<" + SaplN3Constants.SAPL_NS + "or>";
	public static final String Optional = "<" + SaplN3Constants.SAPL_NS + "Optional>";
	public static final String add = "<" + SaplN3Constants.SAPL_NS + "add>";
	public static final String Variable = "<" + SaplN3Constants.SAPL_NS + "Variable>";
	public static final String eventFromSocket = "<" + SaplN3Constants.SAPL_NS + "eventFromSocket>";
	public static final String Container = "<" + SaplN3Constants.SAPL_NS + "Container>";
	public static final String Now = "<" + SaplN3Constants.SAPL_NS + "Now>";
	public static final String Time = "<" + SaplN3Constants.SAPL_NS + "Time>";
	public static final String Date = "<" + SaplN3Constants.SAPL_NS + "Date>";
	public static final String DO = "<" + SaplN3Constants.SAPL_NS + "do>";//do
	public static final String NULL = "<" + SaplN3Constants.SAPL_NS + "null>";//null
	public static final String Start = "<" + SaplN3Constants.SAPL_NS + "Start>";
	public static final String End = "<" + SaplN3Constants.SAPL_NS + "End>";
	public static final String Success = "<" + SaplN3Constants.SAPL_NS + "Success>";
	public static final String Fail = "<" + SaplN3Constants.SAPL_NS + "Fail>";
	public static final String Denied = "<" + SaplN3Constants.SAPL_NS + "Denied>";
	public static final String missingRAB = "<" + SaplN3Constants.SAPL_NS + "missingRAB>";
	public static final String haveName = "<" + SaplN3Constants.SAPL_NS + "haveName>";
	public static final String executionID = "<" + SaplN3Constants.SAPL_NS + "executionID>";
	public static final String requires = "<" + SaplN3Constants.SAPL_NS + "requires>";
	public static final String existsWhile = "<" + SaplN3Constants.SAPL_NS + "existsWhile>";

	public static final URI SAPL_NS_URI = URITools.createUncheckedURI(SaplN3Constants.SAPL_NS.substring(0,
			SaplN3Constants.SAPL_NS.length() - 1));
	public static final URI RAB_NS_URI = URITools.createUncheckedURI(SaplN3Constants.RAB_NS.substring(0,
			SaplN3Constants.RAB_NS.length() - 1));
	public static final URI PARAM_NS_URI = URITools.createUncheckedURI(SaplN3Constants.PARAM_NS.substring(0, SaplN3Constants.PARAM_NS
			.length() - 1));
}
