package ubiware.util;

import ubiware.core.UbiwareAgent;

public class StatementIDGenerator extends Counter {
	/**
	 * The maximum number of digits a string representation from a long in base 10 can have 9223372036854775807 is the longest long.
	 * 
	 */
	private final static int MAX_LONG_STRING_LENGTH = 19;

	/**
	 * The maximum length a statement ID can ever have, used as bounds for the Stringbuilder.
	 */
	private final static int MAX_ID_LENGTH = StatementIDGenerator.MAX_LONG_STRING_LENGTH + UbiwareAgent.STATEMENT_PREFIX.length();

	/**
	 * get the next unique statement ID
	 * 
	 * @return String representation of the ID
	 */
	public String getNewStatementID() {
		//return UbiwareAgent.STATEMENT_PREFIX + String.valueOf(super.getNextNumber());
		StringBuilder builder = new StringBuilder(StatementIDGenerator.MAX_ID_LENGTH);
		builder.append(UbiwareAgent.STATEMENT_PREFIX);
		builder.append(super.getNextNumber());
		return builder.toString();
	}
}
