package ubiware.util;

import java.io.ByteArrayInputStream;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Iterator;

import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;

public class XSLTAdapter {
	private XSLTAdapter() {
		// TODO Auto-generated constructor stub
	}

	public static String transform(String xmlstring, String xsltstring, HashMap<String, String> parameters) {

		javax.xml.transform.Source xsltSource;
		javax.xml.transform.Source xmlSource;
		try {
			xsltSource = new javax.xml.transform.stream.StreamSource(new ByteArrayInputStream(xsltstring.getBytes("UTF-8")));
			xmlSource = new javax.xml.transform.stream.StreamSource(new ByteArrayInputStream(xmlstring.getBytes("UTF-8")));

			StringWriter sw = new StringWriter();
			javax.xml.transform.Result xsltresult = new javax.xml.transform.stream.StreamResult(sw);

			javax.xml.transform.TransformerFactory transFact = javax.xml.transform.TransformerFactory.newInstance();

			javax.xml.transform.Transformer trans;
			try {
				trans = transFact.newTransformer(xsltSource);
				Iterator<String> it = parameters.keySet().iterator();
				while (it.hasNext()) {
					String key = it.next();
					String value = parameters.get(key);
					if (value != null) {
						trans.setParameter(key, value);
					}
				}
				trans.transform(xmlSource, xsltresult);
				sw.flush();
				return sw.toString();

			} catch (TransformerConfigurationException e) {
				e.printStackTrace();
			} catch (TransformerException e) {
				e.printStackTrace();
			}
		} catch (UnsupportedEncodingException e1) {

			e1.printStackTrace();
		}

		return null;
	}
}
