package ubiware.util.saplbuilder;

/**
 * A container in the S-apl sense, a container contains zero or more statements. A container can act as both a subject or predicate of a
 * statement.
 * 
 * @author Michael Cochez for Ubiware project
 * @since 17 Aug 2010
 */
public class Container extends StatementContainer implements Subject, Object {
	/**
	 * Creates a container with the default initial capacity of 5.
	 */
	public Container() {
		super(5);
	}

	/**
	 * Creates a container with the given initial capacity.
	 * 
	 * @param initialCapacity
	 */
	public Container(int initialCapacity) {
		super(initialCapacity);
	}

	/**
	 * Generates a S-apl representation of this container.
	 */
	@Override
	public void generateSapl(StringBuilder builder) {
		builder.append('{');
		builder.append(' ');
		super.generateSapl(builder);
		builder.append(' ');
		builder.append("}");
	}

}
