package ubiware.util.saplbuilder;

/**
 * Interface implemented by classes which can act as a object of a statement. <b>Caution:</b> when implementing this interface by your class
 * or especially importing it in your class, the mening of 'Object' without any further prefixing will no longer refer to java.lang.Object
 * but ubiware.util.saplbuilder.Object . This in particular changes the meaning of <code><pre>public boolean equals (Object object){
 * }</pre></code> Which should be changed to <code><pre>public boolean equals (java.lang.Object object){
 * }</pre></code>
 * 
 * @author Michael Cochez for Ubiware project
 * @since 17 Aug 2010
 */
public interface Object {
	/**
	 * Generate the s-apl representation for this object.
	 * 
	 * @param builder
	 *            The StringBuilder on which the representation must be appended.
	 */
	void generateSapl(StringBuilder builder);

}
