package ubiware.util.saplbuilder;

import java.io.IOException;
import java.util.Iterator;

import com.google.common.base.Preconditions;
import com.google.common.io.CharStreams;

public class Parser {

	/**
	 * !!! This method does currently not really check its argument!!
	 * @param inputStream
	 * @return
	 * @throws IOException 
	 */
	public static SaplDocument parse(Readable inputStream) throws ParseException, IOException {
		StringBuilder sb = new StringBuilder();
		CharStreams.copy(inputStream, sb);
		return new FakeDocument(sb.toString());
	}

	/**
	 * !!! This method does currently not really check its argument!!
	 * @param inputStream
	 * @return
	 * @throws IOException 
	 */
	public static SaplDocument parse(String input) throws ParseException {
		Preconditions.checkNotNull(input);
		return new FakeDocument(input);
	}

	public static Container parseToContainer(String input) throws ParseException {
		Preconditions.checkNotNull(input);
		return new FakeContainer(input);
	}

	private static class FakeDocument extends SaplDocument {

		private String value;

		public FakeDocument(String value) {
			super(0);
			this.value = value;
		}

		@Override
		public void addStatement(Statement statement) {
			throw new UnsupportedOperationException("A parsed document can currently not take any new statements");
		}

		@Override
		public void addStatement(Subject subject, Predicate predicate, Object object) {
			throw new UnsupportedOperationException("A parsed document can currently not take any new statements");
		}

		@Override
		public void addStatements(StatementContainer sc) {
			throw new UnsupportedOperationException("A parsed document can currently not take any new statements");
		}

		@Override
		public Iterator<Statement> iterator() {
			throw new UnsupportedOperationException("No iteration over parsed sapl possible");
		}

		@Override
		public String generateSapl() {
			return value;
		}

		@Override
		public void generateSapl(StringBuilder builder) {
			builder.append(value);
		}

	};

	private static class FakeContainer extends Container {

		private String value;

		public FakeContainer(String value) {
			super(0);
			this.value = value;
		}

		@Override
		public void addStatement(Statement statement) {
			throw new UnsupportedOperationException("A parsed document can currently not take any new statements");
		}

		@Override
		public void addStatement(Subject subject, Predicate predicate, Object object) {
			throw new UnsupportedOperationException("A parsed document can currently not take any new statements");
		}

		@Override
		public void addStatements(StatementContainer sc) {
			throw new UnsupportedOperationException("A parsed document can currently not take any new statements");
		}

		@Override
		public Iterator<Statement> iterator() {
			throw new UnsupportedOperationException("No iteration over parsed sapl possible");
		}

		@Override
		public void generateSapl(StringBuilder builder) {
			builder.append('{');
			builder.append(' ');
			builder.append(value);
			builder.append(' ');
			builder.append("}");

		}

	};

}
