package ubiware.util.saplbuilder;

/**
 * Interface implemented by classes which can act as a predicate of a statement.
 * 
 * @author Michael Cochez for Ubiware project
 * @since 17 Aug 2010
 */
public interface Predicate {
	/**
	 * Generate the s-apl representation for this predicate.
	 * 
	 * @param builder
	 *            The StringBuilder on which the representation must be appended.
	 */
	void generateSapl(StringBuilder builder);

}
