package ubiware.web.applications.ubiwaredesktop.ontology;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import ubiware.rdf2bean.core.Storage;
import ubiware.util.saplbuilder.Resource;

public class StorageHelper {
	public static final String NS_UBIM = "http://www.ubiware.jyu.fi/main#";
	public static final String NS_USER = "http://www.ubiware.jyu.fi/user#";

	public static Storage getDefaultStorage() {
		Set<String> props = new HashSet<String>();
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#hasConnection");
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#hasProfile");
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#hasGeoLocation");
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#hasSender");
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#hasReceiver");
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#sentFrom");
		props.add("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");

		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#");
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#");
		// props.add("http://www.ubiware.jyu.fi/apps/socialNetworkApp#");
		Storage s = new Storage(props);
		return s;
	}

	public static String getSingleStringValue(Map<String, Set<String>> properties, Resource uri) {
		String uriString = uri.toString().substring(1, uri.toString().length() - 1);
		Set<String> set = properties.get(uriString);
		if (set == null) {
			return null;
		}
		int setSize = set.size();
		if (setSize == 0) {
			return null;
		} else if (setSize == 1) {
			return set.iterator().next();
		} else {
			return set.iterator().next();
			// TODO: for the future it might be more reasonable to do this:
			// throw new StorageException("Property " + propertyName +
			// " can have at most one value");
		}
	}

	/**
	 * 
	 * @param properties
	 * @param selected
	 * @return
	 * @throws NullPointerException
	 *             if the value does not exists
	 */
	public static boolean getSingleBooleanValue(Map<String, Set<String>> properties, Resource selected) {
		String string = StorageHelper.getSingleStringValue(properties, selected);
		return Boolean.parseBoolean(string);
	}

	public static boolean getSingleOptionalBooleanValue(Map<String, Set<String>> properties, Resource selected, boolean defaultValue) {
		String string = StorageHelper.getSingleStringValue(properties, selected);
		if (string == null) {
			return defaultValue;
		}
		return Boolean.parseBoolean(string);
	}
}
