package ubiware.web.applications.ubiwaredesktop.ontology;

import java.util.Map;
import java.util.Set;

import ubiware.ontology.applications;
import ubiware.rdf2bean.core.RDFResource;
import ubiware.rdf2bean.core.Storage;

public class UbiwareApplication extends RDFResource {

	public static String handledResource = "http://www.ubiware.jyu.fi/applications#app";

	public UbiwareApplication(String resourceURI, Map<String, Set<String>> props, Storage s) {
		super(resourceURI, props, s);
	}

	// private String context;
	// private String isAdminApplication;
	// private String name;

	public boolean getIsSelected() {
		return StorageHelper.getSingleOptionalBooleanValue(this.properties, applications.selected, false);
	}

	//	public boolean getDisplayname() {
	//		return StorageHelper.getSingleOptionalBooleanValue(this.properties, applications.selected, false);
	//	}

	public String getHasDisplayName() {
		return StorageHelper.getSingleStringValue(this.properties, applications.hasDisplayName);
	}

	public boolean getIsMenuVisible() {
		return StorageHelper.getSingleOptionalBooleanValue(this.properties, applications.menuVisible, false);
	}

	public String getWebContext() {
		return StorageHelper.getSingleStringValue(this.properties, applications.webContext);
	}

	public boolean getIsSelectable() {
		return StorageHelper.getSingleBooleanValue(this.properties, applications.selectable);
	}

	public boolean getIsDeselectable() {
		return StorageHelper.getSingleBooleanValue(this.properties, applications.deselectable);
	}

	/*
		public String getName() {
			String propertyName = "name";
			return SocialHelper.getSingleStringValue(this.properties, StorageHelper.NS_UBIM, propertyName);
		}

		public String getIsAdminApplication() {
			String propertyName = "isAdminApplication";
			return SocialHelper.getSingleStringValue(this.properties, StorageHelper.NS_UBIM, propertyName);
		}

		public void setContext(String value) {
			SocialHelper.setSingleStringValue(this.properties, StorageHelper.NS_UBIM, "context", value);
		}

		public void setIsAdminApplication(String value) {
			SocialHelper.setSingleStringValue(this.properties, StorageHelper.NS_UBIM, "isAdminApplication", value);
		}

		public void setName(String value) {
			SocialHelper.setSingleStringValue(this.properties, StorageHelper.NS_UBIM, "name", value);
		}
	/*
		public static void main(String[] args) throws SecurityException, NoSuchFieldException, RepositoryException, RDFParseException,
				MalformedQueryException, QueryEvaluationException, IllegalArgumentException, IOException, InstantiationException,
				IllegalAccessException, InvocationTargetException {
			String rdfCodeAsString = "@prefix ubim: <http://www.ubiware.jyu.fi/main#> . @prefix user: <http://www.ubiware.jyu.fi/user#> . @prefix soc: <http://www.ubiware.jyu.fi/apps/socialNetworkApp#> . @prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> . "
					+ " soc:TwitterApplication rdf:type ubim:UbiwareApplication ; ubim:context \"/twitterAdapter\" ; ubim:isAdminApplication \"false\" ; ubim:name \"TwitterAdapter\" . \n";

			Storage s = SocialHelper.getDefaultStorage();
			s.register(UbiwareApplication.class, UbiwareApplication.handledResource);
			s.read(rdfCodeAsString);

			UbiwareApplication ua = s.getAllResourcesOfThisType(UbiwareApplication.class).iterator().next();
			System.out.println(ua.getUri());
			System.out.println(ua.getContext());
			System.out.println(ua.getIsAdminApplication());
			System.out.println(ua.getName());

		}
	*/

}
